Package: GDCRNATools
Title: GDCRNATools: an R/Bioconductor package for integrative analysis
        of lncRNA, mRNA, and miRNA data in GDC
Version: 1.32.0
Author: Ruidong Li,
	Han Qu,
	Shibo Wang,
	Julong Wei,
	Le Zhang,
	Renyuan Ma,
	Jianming Lu,
	Jianguo Zhu,
	Wei-De Zhong,
	Zhenyu Jia
Maintainer: Ruidong Li <rli012@ucr.edu>,
 Han Qu <hqu002@ucr.edu>
Description: This is an easy-to-use package for downloading, organizing, and integrative analyzing RNA expression 
	data in GDC with an emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory network in cancer. 
	Three databases of lncRNA-miRNA interactions including spongeScan, starBase, and miRcode, as well as three 
	databases of mRNA-miRNA interactions including miRTarBase, starBase, and miRcode are incorporated into the 
	package for ceRNAs network construction. limma, edgeR, and DESeq2 can be used to identify differentially 
	expressed genes/miRNAs. Functional enrichment analyses including GO, KEGG, and DO can be performed based on 
	the clusterProfiler and DO packages. Both univariate CoxPH and KM survival analyses of multiple genes can be 
	implemented in the package. Besides some routine visualization functions such as volcano plot, bar plot, and 
	KM plot, a few simply shiny apps are developed to facilitate visualization of results on a local webpage.
Depends: R (>= 3.5.0)
License: Artistic-2.0
Encoding: UTF-8
LazyData: false
Imports: shiny, jsonlite, rjson, XML, limma, edgeR, DESeq2,
        clusterProfiler, DOSE, org.Hs.eg.db, biomaRt, survival,
        survminer, pathview, ggplot2, gplots, DT, GenomicDataCommons,
        BiocParallel
Suggests: knitr, testthat, prettydoc, rmarkdown
VignetteBuilder: knitr
biocViews: ImmunoOncology, GeneExpression, DifferentialExpression,
        GeneRegulation, GeneTarget, NetworkInference, Survival,
        Visualization, GeneSetEnrichment, NetworkEnrichment, Network,
        RNASeq, GO, KEGG
RoxygenNote: 6.1.0
Packaged: 2026-04-28 22:11:31 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/GDCRNATools
git_branch: RELEASE_3_23
git_last_commit: 0c4a332
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no

### *GDCRNATools* - an R/Bioconductor package for downloading, organizing, and integrative analyzing lncRNA, mRNA, and miRNA data in GDC


* **A tutorial is avaialable here: [GDCRNATools Wiki page](https://github.com/rli012/GDCRNATools/wiki)**

* **If you use `GDCRNATools` in your published research, please cite:**  
Li, R., Qu, H., Wang, S., Wei, J., Zhang, L., Ma, R., Lu, J., Zhu, J., Zhong, W., and Jia, Z. (2018). GDCRNATools: an R/Bioconductor package for integrative analysis of lncRNA, miRNA and mRNA data in GDC. Bioinformatics 34, 2515-2517. https://doi.org/10.1093/bioinformatics/bty124.

* **Please add my WeChat: rli012 or email to rli012@ucr.edu if you have further questions.**

***

The [Genomic Data Commons (GDC)](https://portal.gdc.cancer.gov/) maintains standardized genomic, clinical, and biospecimen data from National Cancer Institute (NCI) programs including [The Cancer Genome Atlas (TCGA)](https://tcga-data.nci.nih.gov/) and [Therapeutically Applicable Research To Generate Effective Treatments (TARGET)](https://ocg.cancer.gov/programs/target), It also accepts high quality datasets from non-NCI supported cancer research programs, such as genomic data from the [Foundation Medicine](https://www.foundationmedicine.com/).

`GDCRNATools` is an R/Bioconductor package which provides a standard, easy-to-use and comprehensive pipeline for downloading, organizing, and integrative analyzing RNA expression data in the GDC portal with an emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory network in cancer.

##' @title Plots for enrichment analysis
##' @description Bar plot and bubble plot for GO, KEGG, 
##'     and DO functional enrichment analysis
##' @param enrichment a dataframe generated from 
##'     \code{\link{gdcEnrichAnalysis}}
##' @param type type of the plot, should be one of \code{'bar'} 
##'     and \code{'bubble'}
##' @param category which category should be plotted. Possible values are 
##'     \code{'KEGG'}, \code{'GO'}, \code{'GO_BP'}, \code{'GO_CC'}, 
##'     \code{'GO_MF'}, and \code{'DO'}.
##'     Default is \code{'KEGG'}
##' @param num.terms number of terms to be plotted. Default is \code{10}
##' @param bar.color color of the bar plot. Default is \code{'black'}
##' @return A bar plot or bubble plot of functional enrichment analysis
##' @import ggplot2
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Enrichment plots #######
##' enrichOutput<-data.frame(Terms=c('hsa05414~Dilated cardiomyopathy (DCM)',
##'                                 'hsa04510~Focal adhesion',
##'                                 'hsa05205~Proteoglycans in cancer'),
##'                             Category=rep('KEGG',3), 
##'                             FDR=c(0.001,0.002,0.003))
##' gdcEnrichPlot(enrichment=enrichOutput, type='bar', category='KEGG')
gdcEnrichPlot <- function(enrichment, type='bar', 
    category='KEGG', num.terms=10, bar.color='black') {

    goBP <- enrichment[enrichment$Category=='GO_BP',]
    goCC <- enrichment[enrichment$Category=='GO_CC',]
    goMF <- enrichment[enrichment$Category=='GO_MF',]
    kegg <- enrichment[enrichment$Category=='KEGG',]
    DO   <- enrichment[enrichment$Category=='DO',]
    
    if (nrow(goBP) > num.terms) {
        goBP <- goBP[seq_len(num.terms),]
    }
    
    if (nrow(goCC) > num.terms) {
        goCC <- goCC[seq_len(num.terms),]
    }
    
    if (nrow(goMF) > num.terms) {
        goMF <- goMF[seq_len(num.terms),]
    }
    
    if (nrow(kegg) > num.terms) {
        kegg <- kegg[seq_len(num.terms),]
    }
    
    if (nrow(DO) > num.terms) {
        DO <- DO[seq_len(num.terms),]
    }
    
    
    if (category == 'GO') {
        go <- rbind(goBP, goCC, goMF)
        
        if (type=='bubble') {
            go$Terms <- paste(go$Terms, '[', go$Category, ']', sep='')
            
            enrichBubblePlotFun(go)
        } else if (type=='bar') {
            enrichBarPlotFun(go, type='multiple')
        }
        
    } else if (category %in% c('GO_BP','GO_CC','GO_MF','KEGG', 'DO')) {
        goList <- list(goBP, goCC, goMF, kegg, DO)
        names(goList) <- c('GO_BP','GO_CC','GO_MF', 'KEGG', 'DO')
        go <- goList[[category]]
        
        if (type=='bubble') {
            enrichBubblePlotFun(go)
        } else if (type=='bar') {
            enrichBarPlotFun(go, bar.color=bar.color)
        }
        
    }

}


enrichBubblePlotFun <- function(kegg, pval=0.01) {
    keggBasic = ggplot(data=kegg, mapping=aes(x=Terms, 
        y=foldEnrichment,color=FDR,size=Counts))
    keggBasic+geom_point()+ coord_flip() + 
        scale_x_discrete(limits=rev(kegg$Terms)) + 
        scale_colour_gradientn(limits=c(0,pval),
            colors= c("red","yellow","green")) + 
        xlab('')+ylab('Fold enrichment') +
        guides(shape = guide_legend(order=1),
            colour = guide_colourbar(order=2)) + 
        theme_bw()+theme(axis.line = element_line(colour = "black"),
            panel.grid.minor = element_blank(),
            panel.border = element_rect(colour='black'),
            panel.background = element_blank()) +
        ggtitle("") + theme(plot.title = element_text(hjust = 0.5, size=20)) +
        theme(axis.text.y=element_text(size=14), 
            axis.title=element_text(size=15),
            axis.text.x=element_text(size=14)) + 
        theme(legend.text = element_text(size = 14),
            legend.title = element_text(size = 14)) +
        theme(strip.text = element_text(size = 14), 
            legend.key.size = unit(0.8,'cm'))
}


enrichBarPlotFun <- function(kegg, type='single', bar.color='black') {
    
    if (type=='single') {
        keggBasic = ggplot(data=kegg, mapping=aes(x=Terms, y=-log(FDR,10)))
        keggBasic + geom_bar(stat='identity',fill=bar.color) + 
            scale_x_discrete(limits=rev(kegg$Terms)) + 
            ylim(0, max(-log(kegg$FDR,10))) + 
            theme(legend.title=element_blank())+ylab('-log10(FDR)')+
            xlab('') + coord_flip() + 
            theme_bw()+theme(axis.line = element_line(colour = "black"),
                panel.grid.major = element_blank(),
                panel.grid.minor = element_blank(),
                panel.border = element_rect(colour='white'),
                panel.background = element_blank()) +
            theme(axis.text.y=element_text(size=14), 
                axis.title=element_text(size=15),
                axis.text.x=element_text(size=14)) + 
            theme(legend.position = 'none')
        
    } else if (type=='multiple') {
        keggBasic = ggplot(data=kegg, mapping=aes(x=Terms, y=-log(FDR,10), 
            fill=Category))
        keggBasic + geom_bar(stat='identity') + 
            scale_x_discrete(limits=rev(kegg$Terms)) + 
            ylim(0, max(-log(kegg$FDR,10))) + 
            theme(legend.title=element_blank())+
            ylab('-log10(FDR)')+xlab('') + coord_flip() + 
            scale_fill_hue(name='',breaks=kegg$Category, 
                labels=kegg$Category) +
            theme_bw()+theme(axis.line = element_line(colour = "black"),
                panel.grid.major = element_blank(),
                panel.grid.minor = element_blank(),
                panel.border = element_rect(colour='white'),
                panel.background = element_blank()) +
            theme(axis.text=element_text(size=14), 
                axis.title=element_text(size=15)) + 
            theme(legend.text = element_text(size=16))
    }
}

##' @title Competing endogenous RNAs (ceRNAs) analysis
##' @description Identify ceRNAs by 
##'     (1) number of shared miRNAs between lncRNA and mRNA; 
##'     (2) expression correlation of lncRNA and mRNA;
##'     (3) regulation similarity of shared miRNAs on lncRNA and mRNA;
##'     (4) sensitivity correlation
##' @param lnc a vector of Ensembl long non-coding gene ids 
##' @param pc a vector of Ensembl protein coding gene ids 
##' @param deMIR a vector of differentially expressed miRNAs. 
##'     Default is \code{NULL}
##' @param lnc.targets a character string specifying the database 
##'     of miRNA-lncRNA interactions.
##'     Should be one of \code{'spongeScan'}, \code{'starBase'}, 
##'     and \code{'miRcode'}. Default is \code{'starBase'}. \cr\cr
##'     Or a \code{list} of miRNA-lncRNA interactions generated by users
##' @param pc.targets a character string specifying the database of 
##'     miRNA-lncRNA interactions.
##'     Should be one of \code{'spongeScan'}, \code{'starBase'}, 
##'     and \code{'miRcode'}. Default is \code{'starBase'}. \cr\cr
##'     Or a \code{list} of miRNA-lncRNA interactions generated by users
##' @param rna.expr \code{\link[limma]{voom}} 
##'     transformed gene expression data
##' @param mir.expr \code{\link[limma]{voom}} 
##'     transformed mature miRNA expression data
##' @return A dataframe containing ceRNA pairs, expression correlation 
##'     between lncRNA and mRNA, the number and hypergeometric significance 
##'     of shared miRNAs, regulation similarity score, and the mean sensitity 
##'     correlation (the difference between Pearson correlation and partial 
##'     correlation) of multiple lncRNA-miRNA-mRNA triplets, etc.
##' @references
##'     Paci P, Colombo T, Farina L. Computational analysis identifies 
##'     a sponge interaction network  between long non-coding RNAs and 
##'     messenger RNAs in human breast cancer.  BMC systems biology. 
##'     2014 Jul 17;8(1):83.
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### ceRNA network analysis #######
##' deLNC <- c('ENSG00000260920','ENSG00000242125','ENSG00000261211')
##' dePC <- c('ENSG00000043355','ENSG00000109586','ENSG00000144355')
##' genes <- c(deLNC, dePC)
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01', 
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01', 
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##' rnaExpr <- data.frame(matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6), 
##'                     stringsAsFactors=FALSE)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' 
##' mirExpr <- data.frame(matrix(c(7.7,7.4,7.9,8.9,8.6,9.5,
##'                     5.1,4.4,5.5,8.5,4.4,3.5,
##'                     4.9,5.5,6.9,6.1,5.5,4.1,
##'                     12.4,13.5,15.1,15.4,13.0,12.8,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,2.7,6.2,1.5,4.4,4.2),6,6),
##'                     stringsAsFactors=FALSE)
##' colnames(mirExpr) <- samples
##' rownames(mirExpr) <- c('hsa-miR-340-5p','hsa-miR-181b-5p',
##'                     'hsa-miR-181a-5p', 'hsa-miR-181c-5p',
##'                     'hsa-miR-199b-5p','hsa-miR-182-5p')
##' 
##' ceOutput <- gdcCEAnalysis(lnc       = deLNC, 
##'                         pc          = dePC, 
##'                         lnc.targets = 'starBase', 
##'                         pc.targets  = 'starBase', 
##'                         rna.expr    = rnaExpr, 
##'                         mir.expr    = mirExpr)
gdcCEAnalysis <- function(lnc, pc, deMIR=NULL, lnc.targets='starBase', 
    pc.targets='starBase', rna.expr, mir.expr) {
    
    hyperOutput <- hyperTestFun(lnc, pc, deMIR, 
        lnc.targets=lnc.targets, pc.targets=pc.targets)
    message ('Step 1/3: Hypergenometric test done !')
    
    regOutput <- multiRegTestFun(hyperOutput, rna.expr=rna.expr, 
        mir.expr=mir.expr)
    message ('Step 2/3: Correlation analysis done !\n',
        'Step 3/3: Regulation pattern analysis done !')
    
    ceOutput <- data.frame(hyperOutput, regOutput, row.names=NULL)
    
    return(ceOutput)
}


#### hypergeometric test
hyperTestFun <- function(lnc, pc, deMIR, 
    lnc.targets='starBase', pc.targets='starBase') {
    
    if (length(lnc.targets) > 1) {
        lnc.targets <- lnc.targets
    } else {
        lnc.targets <- lncTargets[[lnc.targets]]
    }
    
    if (length(pc.targets) > 1) {
        pc.targets <- pc.targets
    } else {
        pc.targets <- pcTargets[[pc.targets]]
    }
    
    mir1 <- unique(unlist(lnc.targets))
    mir2 <- unique(unlist(pc.targets))
    
    mirs <- union(mir1,mir2)
    popTotal <- length(mirs)
    
    ceLNC <- lnc[lnc %in% names(lnc.targets)]
    cePC <- pc[pc %in% names(pc.targets)]
    #ceMIR <- mir[mir %in% mirs]
    
    hyperOutput <- list()
    i <- 0
    for (lncID in ceLNC) {
        listTotal <- length(lnc.targets[[lncID]])
        for (gene in cePC) {
            i = i + 1
            ovlp <- intersect(lnc.targets[[lncID]], pc.targets[[gene]])
            
            popHits <- length(pc.targets[[gene]])
            Counts <- length(ovlp)
            
            ovlpMIRs <- paste(ovlp, collapse = ',')
            foldEnrichment <- Counts/listTotal*popTotal/popHits
            pValue <- phyper(Counts-1, popHits, popTotal-popHits, 
                listTotal, lower.tail=FALSE, log.p=FALSE)
            
            ceMIR <- Reduce(intersect, list(ovlp, deMIR))
            deMIRs <- paste(ceMIR, collapse = ',')
            deMIRCounts <- length(ceMIR)
            
            hyperOutput[[i]] <- c(lncID, gene, Counts, listTotal,
                popHits,popTotal,foldEnrichment,pValue,ovlpMIRs,
                deMIRCounts, deMIRs)
            
        }
    }
    
    #hyperOutput <- Reduce(rbind, hyperOutput)  ## slower
    hyperOutput <- do.call(rbind, hyperOutput)
    #hyperOutput <- rbind_list(hyperOutput) ## not test
    
    colnames(hyperOutput) <- c('lncRNAs','Genes','Counts','listTotal',
        'popHits','popTotal','foldEnrichment','hyperPValue','miRNAs',
        'deMIRCounts','deMIRs')
    hyperOutput <- as.data.frame(as.matrix(hyperOutput), 
        stringsAsFactors=FALSE)
    hyperOutput <- hyperOutput[as.numeric(hyperOutput$Counts)>0,]
    
    #hyperOutput$FDR <- p.adjust(as.numeric(as.character(hyperOutput$pValue)),
    #method = 'fdr')
    #hyperOutput <- hyperOutput[hyperOutput$Counts>0,]
    #hyperOutput$lncRNAs <- ensembl2symbolFun(hyperOutput$lncRNAs)
    #hyperOutput$gene <- ensembl2symbolFun(hyperOutput$gene)
    
    if (is.null(deMIR)) {
        hyperOutput <- hyperOutput[,! colnames(hyperOutput) %in% 
            c('deMIRCounts','deMIRs')]
    }
    
    return (hyperOutput)
}



########################################################
######## other scores
multiRegFun <- function(lnc, pc, mirs, rna.expr, mir.expr) {
    lncDa <- unlist(rna.expr[lnc,])
    pcDa <- unlist(rna.expr[pc,])
    
    corpl <- cor.test(pcDa, lncDa, alternative='greater')
    ppl <- corpl$p.value
    regpl <- corpl$estimate
    
    mirs <- as.character(mirs)
    
    if (mirs == '') {
        reg <- NA
        lncACT <- NA
        partialSen <- NA
        cosCol <- NA
        
    } else {
        mirs <- unlist(strsplit(mirs, ',', fixed=TRUE))
        mirCor <- vapply(mirs, function(mir) 
            mirCorTestFun(lncDa, pcDa, mir, mir.expr), 
            numeric(2))
        
        reglm <- mirCor[1,]
        regpm <- mirCor[2,]
        
        regSim <- 1-mean((abs(reglm - regpm)/(abs(reglm) + abs(regpm)))
            ^length(mirs))
        #lncACT <- mean((abs(regpl)+abs(reglm)+abs(regpm))/3)
        sppc <- mean(regpl-(regpl-reglm*regpm)/(sqrt(1-reglm^2)*
            sqrt(1-regpm^2)))
        #cos <- sum(reglm*regpm)/(sqrt(sum(reglm^2))*sqrt(sum(regpm^2)))
        #col <- sum(abs(reglm)*abs(regpm))/(sqrt(sum(abs(reglm)))*
        #sqrt(sum(abs(regpm))))
        #cosCol <- (cos+col)/2
        
    }
    
    #scores <- c(regpl, ppl, reg, lncACT, partialSen, cosCol)
    scores <- c(cor=regpl, corPValue=ppl, regSim, sppc)
    return (scores)
}



multiRegTestFun <- function(hyperOutput, rna.expr, mir.expr) {

    samples <- intersect(colnames(rna.expr), colnames(mir.expr))
    
    rna.expr <- rna.expr[,samples]
    mir.expr <- mir.expr[,samples]
    
    lncID <- hyperOutput$lncRNAs
    pcID <- hyperOutput$Genes
    mirID <- hyperOutput$miRNAs
    
    
    reg <- vapply(seq_len(nrow(hyperOutput)), function(i) 
        multiRegFun(lncID[i], pcID[i], mirID[i], rna.expr, mir.expr),
        numeric(4))
    
    reg <- t(reg)
    colnames(reg) <- c('cor','corPValue','regSim', 'sppc')
    return (data.frame(reg))
}



mirCorTestFun <- function(lncDa, pcDa, mir, mir.expr) {
    mirDa <- unlist(mir.expr[mir,])
    
    corlm <- cor.test(lncDa, mirDa, alternative='less')
    corpm <- cor.test(pcDa, mirDa, alternative='less')
    
    reglm <- corlm$estimate
    regpm <- corpm$estimate
    
    return (c(reglm, regpm)) ## lnc then pc
}

##' @title Merge RNA/miRNAs raw counts data
##' @description Merge raw counts data that is downloaded from GDC to a 
##'     single expression matrix
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @param path path to downloaded files for merging
##' @param data.type one of \code{'RNAseq'} and \code{'miRNAs'}
##' @param organized logical, whether the raw counts data have already
##'     been organized into a single folder (eg., data downloaded by the
##'     'GenomicDataCommons' method are already organized). 
##'     Default is \code{FALSE}.
##' @return A dataframe or numeric matrix of raw counts data with rows 
##'     are genes or miRNAs and columns are samples
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Merge RNA expression data #######
##' metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', 
##'     data.type='RNAseq')
##' \dontrun{rnaExpr <- gdcRNAMerge(metadata=metaMatrix, path='RNAseq/', 
##'     data.type='RNAseq')}
gdcRNAMerge <- function(metadata, path, data.type, organized=FALSE) {
    
    #if (endsWith(path, '/')) {
    #  path = substr(path, 1, nchar(path)-1)
    #}
    
    if (organized==TRUE) {
        filenames <- file.path(path, metadata$file_name, 
            fsep = .Platform$file.sep)
    } else {
        filenames <- file.path(path, metadata$file_id, metadata$file_name, 
            fsep = .Platform$file.sep)
    }
    
    if (data.type=='RNAseq') {
        message ('############### Merging RNAseq data ################\n',
            '### This step may take a few minutes ###\n')
        
        rnaMatrix <- do.call("cbind", lapply(filenames, function(fl) 
            read.table(fl, header = T, stringsAsFactors = F, sep = '\t', comment.char = '#')$unstranded))
        
        rownames(rnaMatrix) <- read.table(filenames[1], header = T, 
                stringsAsFactors = F, sep = '\t', comment.char = '#')$gene_id
        
        filter <- grep('PAR_Y', rownames(rnaMatrix))
        rnaMatrix <- rnaMatrix[-filter,]
        
        rownames(rnaMatrix) <- unlist(lapply(strsplit(rownames(rnaMatrix), 
            '.', fixed=TRUE), function(gene) gene[1]))
        
        colnames(rnaMatrix) <- metadata$sample
        
        rnaMatrix <- rnaMatrix[biotype$ensemblID,]
        
        nSamples = ncol(rnaMatrix)
        nGenes = nrow(rnaMatrix)
        
        message (paste('Number of samples: ', nSamples, '\n', sep=''),
            paste('Number of genes: ', nGenes, '\n', sep=''))
        
        return (rnaMatrix)
    } else if (data.type=='pre-miRNAs') {
        message ('############### Merging pre-miRNAs data ################\n',
                 '### This step may take a few minutes ###\n')
        
        rnaMatrix <- do.call("cbind", lapply(filenames, function(fl) 
            read.delim(fl)$read_count))
        rownames(rnaMatrix) <- read.delim(filenames[1])$miRNA_ID
        
        colnames(rnaMatrix) <- metadata$sample
        
        nSamples = ncol(rnaMatrix)
        nGenes = nrow(rnaMatrix)
        
        message (paste('Number of samples: ', nSamples, '\n', sep=''),
                 paste('Number of genes: ', nGenes, '\n', sep=''))
        
        return (rnaMatrix)
        
        
    } else if (data.type=='miRNAs') {
        message ('############### Merging miRNAs data ###############\n')
        
        mirMatrix <- lapply(filenames, function(fl) cleanMirFun(fl))
        #mirs <- sort(unique(names(unlist(mirMatrix))))
        mirs <- rownames(mirbase)
        mirMatrix <- do.call('cbind', lapply(mirMatrix, 
            function(expr) expr[mirs]))
        
        rownames(mirMatrix) <- mirbase$v21[match(mirs,rownames(mirbase))]
        colnames(mirMatrix) <- metadata$sample
        
        mirMatrix[is.na(mirMatrix)] <- 0
        
        nSamples = ncol(mirMatrix)
        nGenes = nrow(mirMatrix)
        
        message (paste('Number of samples: ', nSamples, '\n', sep=''),
            paste('Number of miRNAs: ', nGenes, '\n', sep=''))
        
        return (mirMatrix)
    } else {
        return ('error !!!')
    }
}


cleanMirFun <- function(fl) {
    expr <- read.table(fl, header=TRUE, stringsAsFactors = FALSE)
    expr <- expr[startsWith(expr$miRNA_region, "mature"),]
    expr <- aggregate(expr$read_count, list(expr$miRNA_region), sum)
    
    mirs <- unlist(lapply(strsplit(expr$Group.1, ',', fixed=TRUE),
        function(mir) mir[2]))
    
    expr <- expr[,-1]
    names(expr) <- mirs
    #rownames(expr) <- mirs
    return(expr)
}

##' @title Download clinical data in GDC
##' @description Download clinical data in GDC 
##'     either by providing the manifest file or 
##'     specifying the project id and data type
##' @param manifest menifest file that is downloaded from the GDC cart. 
##'     If provided, files whose UUIDs are in the manifest file will be 
##'     downloaded via gdc-client, otherwise, \code{project id} argument 
##'     should be provided to download data automatically. 
##'     Default is \code{NULL}
##' @param project.id project id in GDC
##' @param directory the folder to save downloaded files. 
##'     Default is \code{'Clinical'}
##' @param write.manifest logical, whether to write out the manifest file
##' @param method method that is used to download data. Either 
##'     \code{'GenomicDataCommons'} which is a well established method 
##'     developed in the \pkg{GenomicDataCommons'} package, or alternatively 
##'     \code{'gdc-client'} which uses the \code{gdc-client} tool developed 
##'     by GDC. Default is \code{'gdc-client'}.
##' @return downloaded files in the specified directory
##' @export
##' @author Ruidong Li and Han Qu
##' @examples
##' ####### Download Clinical data by manifest file #######
##' manifest <- 'Clinical.manifest.txt'
##' \dontrun{gdcClinicalDownload(manifest  = manifest,
##'                     directory = 'Clinical')}
##'                    
##' ####### Download Clinical data by project id #######
##' project <- 'TCGA-PRAD'
##' \dontrun{gdcClinicalDownload(project.id     = project, 
##'                     write.manifest = TRUE,
##'                     directory      = 'Clinical')}
gdcClinicalDownload <- function(manifest=NULL, project.id, 
    directory='Clinical', write.manifest=FALSE, method='gdc-client') {

    data.type = 'Clinical'
    
    if (! is.null(manifest)) {
        manifestDownloadFun(manifest=manifest,directory=directory)
        
    } else {
        
        url <- gdcGetURL(project.id=project.id, data.type=data.type)
        manifest <- read.table(paste(url, '&return_type=manifest', sep=''), 
            header=TRUE, stringsAsFactors=FALSE)
        
        systime <- gsub(' ', 'T', Sys.time())
        systime <- gsub(':', '-', systime)
        
        manifile <- paste(project.id, data.type, 'gdc_manifest', 
            systime, 'txt', sep='.')
        write.table(manifest, file=manifile, row.names=FALSE, 
            sep='\t', quote=FALSE)
        
        if (method=='GenomicDataCommons') {
            ex <- manifest$filename %in% dir(directory)
            nonex <- ! ex
            numFiles <- sum(ex)
            
            if(numFiles > 0) {
                message (paste('Already exists',numFiles,'files !',sep=' '))
                
                if (sum(nonex) > 0 ) {
                    message (paste('Download the other', 
                        sum(nonex), 'files !', sep=' '))
                    manifest <- manifest[nonex,]
                    fnames = lapply(manifest$id,gdcdata,
                        destination_dir=directory,overwrite=TRUE,
                        progress=TRUE)
                } else {
                    return(invisible())
                }
                
            } else {
                fnames = lapply(manifest$id,gdcdata,
                    destination_dir=directory,overwrite=TRUE,
                    progress=TRUE)
            }
        } else if (method=='gdc-client') {
            manifestDownloadFun(manifest=manifile,directory=directory)
        }
        
        if (write.manifest == FALSE) {
            invisible(file.remove(manifile))
        }
    }
}



##' @title Merge clinical data
##' @description Merge clinical data in \code{.xml} files 
##'     that are downloaded from GDC to a dataframe
##' @param path path to downloaded files for merging
##' @param key.info logical, whether to return the key clinical 
##'     information only. If \code{TRUE}, only clinical information 
##'     such as age, stage, grade, overall survial, etc. will be returned
##' @param organized logical, whether the clinical data have already
##'     been organized into a single folder (eg., data downloaded by the
##'     'GenomicDataCommons' method are already organized). 
##'     Default is \code{FALSE}.
##' @importFrom XML xmlParse
##' @importFrom XML xmlApply
##' @importFrom XML getNodeSet
##' @importFrom XML xmlValue
##' @importFrom XML xmlName
##' @return A dataframe of clinical data with rows are patients 
##'     and columns are clinical traits
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Merge clinical data #######
##' path <- 'Clinical/'
##' \dontrun{clinicalDa <- gdcClinicalMerge(path=path, key.info=TRUE)}
gdcClinicalMerge <- function(path, key.info=TRUE, organized=FALSE) {

    options(stringsAsFactors = FALSE)
    
    #if (endsWith(path, '/')) {
    #  path = substr(path, 1, nchar(path)-1)
    #}
    
    message ('############### Merging Clinical data ###############\n')
    
    if (organized==TRUE) {
        filenames <- file.path(path, getXMLFile(path), 
            fsep = .Platform$file.sep)
    } else {
        folders <- file.path(path, dir(path), fsep = .Platform$file.sep)
        folders <- folders[dir.exists(folders)]
        filenames <- file.path(folders, unlist(lapply(folders, function(v) 
            getXMLFile(v))), fsep = .Platform$file.sep)
    }
    
    df <- lapply(filenames, function(fl) parseXMLFun(fl))
    traits <- unique(names(unlist(df)))
    xmlMatrix <- do.call('cbind', lapply(df, function(v) v[traits]))
    
    rownames(xmlMatrix) <- traits
    colnames(xmlMatrix) <- xmlMatrix['bcr_patient_barcode',]
    xmlMatrix[xmlMatrix==""]<- "NA"
    xmlMatrix<- data.frame(xmlMatrix)
    if (key.info== TRUE){
        line1<- xmlMatrix[c("age_at_initial_pathologic_diagnosis",
            "ethnicity", "gender", "race","clinical_stage", 
            "clinical_T","clinical_N", "clinical_M", "gleason_grading",
            "gleason_score", "primary_pattern","secondary_pattern",
            "tertiary_pattern","psa","psa_value","days_to_psa"),]
        
        
        ### days_to_death
        
        num3<- grep("^days_to_death", rownames(xmlMatrix))
        t3<- xmlMatrix[num3,]
        t3[t3=='NA']<-NA
        t3[is.na(t3)]<-"0"
        
        line2<- data.frame(t(apply(t3, 2, function(v) max(as.numeric(v)))))
        line2[line2<=0]<- NA
        rownames(line2)<- "days_to_death"
        
        
        ### days_to_last_followup
        
        num4<- grep("^days_to_last_followup", rownames(xmlMatrix))
        t4<- xmlMatrix[num4,]
        
        t4[t4=='NA']<-NA
        t4[is.na(t4)]<-"0"
        
        line3<- data.frame(t(apply(t4, 2, function(v) max(as.numeric(v)))))
        line3[line3<=0]<- NA
        rownames(line3)<- "days_to_last_followup"
        
        
        ### vital_status
        num11<- grep("^vital_status", rownames(xmlMatrix))
        t11<- xmlMatrix[num11,]
        
        t11[t11=='NA']<-NA
        t11[is.na(t11)]<-"0"
        
        line5<- data.frame(t(apply(t11, 2, max)))
        line5[line5=='0']<- NA
        rownames(line5)<- "vital_status"
        
        ### age_at_initial_pathologic_diagnosis
        
        line6<- xmlMatrix[c("initial_pathologic_diagnosis_method", 
            "lymphnodes_examined","number_of_lymphnodes_examined",
            "number_of_lymphnodes_positive_by_he","pathologic_categories", 
            "pathologic_stage","pathologic_T", "pathologic_M","pathologic_N",
            "new_tumor_event"),]
        
        ### days_to_new_tumor_event_after_initial_treatment
        
        
        if (xmlMatrix['disease_code',1]=='LAML') {
            #line7 <- data.frame(t(rep(NA, ncol(xmlMatrix))))
            #rownames(line7)<- "days_to_new_tumor_event_after_initial_treatment"
            
            cleantable<- rbind(line1, line2, line3, line5, line6)
            
            
        } else {
            num5<- grep("^days_to_new_tumor_event_after_initial_treatment", 
                        rownames(xmlMatrix))
            t5<- xmlMatrix[num5,]
            
            t5[t5=='NA']<-NA
            t5[is.na(t5)]<-"999999"
            
            line7<- data.frame(t(apply(t5, 2, function(v) min(as.numeric(v)))))
            line7[line7==999999 | line7<=0]<- NA
            
            rownames(line7)<- "days_to_new_tumor_event_after_initial_treatment"
            
            
            ### new_neoplasm_event_type
            
            num6<- grep("^new_neoplasm_event_type", rownames(xmlMatrix))
            t6<- xmlMatrix[num6,]
            # t6[is.na(t6)]<-"0"
            line8<- NULL
            
            for (i in seq_len(ncol(t6))) {
                t6.1<- t6[which(t6[,i] != "NA"),i]
                t6.1<- paste(t6.1,collapse=",")
                line8<- append(line8,t6.1)
            }
            line8<-data.frame(t(line8))
            line8[line8==""]<- "NA"
            rownames(line8)<-"new_neoplasm_event_type"
            colnames(line8) <- colnames(t6)
            
            
            ### new_tumor_event_after_initial_treatment
            
            num7<- grep("^new_tumor_event_after_initial_treatment", 
                        rownames(xmlMatrix))
            t7<- xmlMatrix[num7,]
            t7[t7=='NA']<-NA
            
            t7[is.na(t7)]<-"0"
            
            t7.1<- data.frame(t((colSums(t7=="YES"))))
            rownames(t7.1)<- "new_tumor_event_after_initial_treatment_yes"
            
            t7.2<- data.frame(t((colSums(t7=="NO"))))
            rownames(t7.2)<- "new_tumor_event_after_initial_treatment_no"
            
            line9<- rbind(t7.1,t7.2)
            
            
            if (xmlMatrix['disease_code',1] %in% c('DLBC','PCPG','TGCT')) {
                cleantable<- rbind(line1, line2, line3, line5, line6, line7, line8, line9)
            } else {
                #### additional_pharmaceutical_therapy
                num<- grep("^additional_pharmaceutical_therapy", rownames(xmlMatrix))
                t1<- xmlMatrix[num,]
                
                t1[t1=='NA']<-NA
                t1[is.na(t1)]<-"0"
                
                t1.1<- data.frame(t((colSums(t1=="YES"))))
                rownames(t1.1)<- "additional_pharmaceutical_therapy_yes"
                
                t1.2<- data.frame(t((colSums(t1=="NO"))))
                rownames(t1.2)<- "additional_pharmaceutical_therapy_no"
                
                line10<- rbind(t1.1,t1.2)
                
                
                ### additional_radiation_therapy
                
                num2<- grep("^additional_radiation_therapy", rownames(xmlMatrix))
                t2<- xmlMatrix[num2,]
                t2[t2=='NA']<-NA
                
                t2[is.na(t2)]<-"0"
                
                t2.1<- data.frame(t((colSums(t2=="YES"))))
                rownames(t2.1)<- "additional_radiation_therapy_yes"
                
                t2.2<- data.frame(t((colSums(t2=="NO"))))
                rownames(t2.2)<- "additional_radiation_therapy_no"
                
                line11<- rbind(t2.1,t2.2)
                
                ########## rbind #########
                
                cleantable<- rbind(line1, line2, line3, line5, line6, line7, 
                                   line8, line9, line10, line11)
                #names(cleantable)<- names(line3)
                #colnames(line7)<- names(line3)
                #cleantable<- rbind(cleantable, line3, line7)
                
            }
            
        }
        
        cleantable <- data.frame(t(cleantable), stringsAsFactors = FALSE)
        
        rownames(cleantable) <- gsub('.', '-', rownames(cleantable), 
            fixed=TRUE)
        
        filter <- grep('^NA',colnames(cleantable))
        
        if (length(filter) > 0) {
            cleantable <- cleantable[,-filter]
        }
        
        return(cleantable)
        
    } else{
        return(xmlMatrix)
    }
}


####
parseXMLFun <- function(fl) {
    doc<-xmlParse(file = fl)
    test1<- xmlApply(getNodeSet(doc, "//*"), xmlValue)
    test2<- xmlApply(getNodeSet(doc, "//*"), xmlName)
    names(test1) <- make.names(unlist(test2), unique = TRUE)
    test1 <- unlist(test1)[-c(1:2)]
    return (test1)
}



####
getXMLFile <- function(folder) {
    files <- dir(folder)
    xmlFile <- files[endsWith(files, '.xml')]
    return (xmlFile)
}

##' @title TMM normalization and voom transformation
##' @description 
##'     Normalize raw counts data by TMM implemented in \pkg{edgeR} 
##'     and then transform it by \code{\link[limma]{voom}} in \pkg{limma}
##' @param counts raw counts of RNA/miRNA expression data
##' @param filter logical, whether to filter out low-expression genes. 
##'     If \code{TRUE}, only genes with \code{cpm > 1} in more than half 
##'     of the samples will be kept. Default is \code{TRUE}
##' @return A dataframe or numeric matrix of TMM normalized and 
##'     \code{\link[limma]{voom}} transformed expression values on 
##'     the log2 scale
##' @references
##'     Robinson MD, McCarthy DJ, Smyth GK. edgeR: a Bioconductor package 
##'     for differential expression analysis of digital gene expression data. 
##'     Bioinformatics. 2010 Jan 1;26(1):139-40. \cr
##'     Law CW, Chen Y, Shi W, Smyth GK. Voom: precision weights unlock 
##'     linear model analysis tools for RNA-seq read counts. Genome biology. 
##'     2014 Feb 3;15(2):R29.
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Normalization #######
##' rnaMatrix <- matrix(sample(1:100,100), 4, 25)
##' rnaExpr <- gdcVoomNormalization(counts=rnaMatrix, filter=FALSE)

gdcVoomNormalization <- function(counts, filter=TRUE) {
    expr = DGEList(counts = counts)
    expr = calcNormFactors(expr)
    if (filter==TRUE) {
        ## filter out low expression genes
        keepALL <- rowSums(cpm(expr) > 1) >= 0.5*ncol(counts)
        nGenes <- as.numeric(summary(keepALL)[2]) + 
            as.numeric(summary(keepALL)[3])
        nKeep <- summary(keepALL)[3]
        
        cat (paste('Total Number of genes: ', nGenes, '\n', sep=''))
        cat (paste('Number of genes for downstream analysis: ', nKeep, 
            '\n', sep=''))
        
        exprALL <- expr[keepALL,,keep.lib.sizes = TRUE]
        v <- voom(exprALL, design=NULL, plot = FALSE)$E
        
    } else if (filter==FALSE) {
        v <- voom(expr, design=NULL, plot = FALSE)$E
    }
    return (v)
}

##' @title Shiny correlation plot
##' @description A simple \pkg{shiny} app to show scatter plot of correlations 
##'     between two genes/miRNAs on local web browser
##' @param gene1 a vector of Ensembl gene ids or miRBase v21 mature miRNA ids
##' @param gene2 a vector of Ensembl gene ids or miRBase v21 mature miRNA ids
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @return a local webpage for visualization of correlation plots
##' @import shiny
##' @export
##' @author Ruidong Li and Han Qu
##' @examples
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' \dontrun{shinyCorPlot(gene1=genes[1:3], gene2=genes[4:5], rna.expr=rnaExpr, 
##'     metadata=metaMatrix)}
shinyCorPlot <- function (gene1, gene2, rna.expr,metadata) {
    ui <- fluidPage(
        headerPanel('Expression correlation of ceRNA pairs'),
        sidebarPanel(
            selectInput('xcol', 'Long non-coding gene', paste(gene1, 
                ' (', ensembl2symbolFun(gene1), ')', sep='')),
            selectInput('ycol', 'Protein coding gene', paste(gene2, 
                ' (', ensembl2symbolFun(gene2), ')', sep=''))
        ),
        mainPanel(
            plotOutput('plot1')
        )
    )
    
    server <- function(input, output, session) {
        output$plot1 <- renderPlot({
            gdcCorPlot(gene1 = strsplit(input$xcol,' (', fixed=TRUE)[[1]][1], 
                gene2 = strsplit(input$ycol,' (', fixed=TRUE)[[1]][1],
                rna.expr = rna.expr,
                metadata = metadata)
        })
    }
    shinyApp(ui = ui, server = server)
}




##' @title Shiny Kaplan Meier (KM) plot
##' @description A simple \pkg{shiny} app to show KM survival curves 
##'     on local web browser
##' @param gene a vector of Ensembl gene ids
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @return a local webpage for visualization of KM plots
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' \dontrun{shinyKMPlot(gene=genes, rna.expr=rnaExpr, 
##'     metadata=metaMatrix)}
shinyKMPlot <- function (gene, rna.expr, metadata) {
    sep=c('1stQu','median','mean','3rdQu')
    ui <- fluidPage(
        headerPanel('Kaplan Meier plot'),
        
        sidebarPanel(
            selectInput('xcol', 'Gene', paste(gene, ' (', 
                ensembl2symbolFun(gene), ')', sep='')),
            selectInput('ycol', 'Separator', sep, selected=sep[2])
        ),
        
        mainPanel(
            plotOutput('plot1')
        )
    )
    
    server <- function(input, output, session) {
        output$plot1 <- renderPlot({
            gdcKMPlot(gene = strsplit(input$xcol,' (', fixed=TRUE)[[1]][1], 
                sep = input$ycol,
                rna.expr = rna.expr,
                metadata = metadata)
        })
    }
    shinyApp(ui = ui, server = server)
}




##' @title Shiny pathview
##' @description A simple \pkg{shiny} app to show pathways genetrated by 
##'     \pkg{pathview} package on local web browser
##' @param gene a vector of numeric values (eg. fold change on log2 scale) 
##'     with names are Ensembl gene ids
##' @param pathways a vector of KEGG pathway ids
##' @param directory the folder to save pathway figures. 
##'     Default is the working directory
##' @return a local webpage for visualization of KEGG maps
##' @importFrom pathview pathview
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' pathways <- c("hsa05414~Dilated cardiomyopathy (DCM)",
##'             "hsa05410~Hypertrophic cardiomyopathy (HCM)",
##'             "hsa05412~Arrhythmogenic right ventricular cardiomyopathy",
##'             "hsa04512~ECM-receptor interaction",
##'             "hsa04510~Focal adhesion",
##'             "hsa04360~Axon guidance",
##'             "hsa04270~Vascular smooth muscle contraction",
##'             "hsa05205~Proteoglycans in cancer",
##'             "hsa04022~cGMP-PKG signaling pathway",
##'             "hsa00480~Glutathione metabolism")
##' \dontrun{shinyPathview(gene=genes, pathways=pathways)}
shinyPathview <- function(gene, pathways, directory='.') {

    if (! dir.exists(directory)) {
        dir.create(directory)
    }
    
    if ( ! endsWith(directory, '/')) {
        directory = paste(directory, '/', sep='')
    }
    
    ui <- fluidPage(
        headerPanel('Pathview'),
        sidebarPanel(
            selectInput('xcol', 'Pathway', pathways)
        ),
        mainPanel(
            plotOutput('plot1')
        )
    )
    
    server <- function(input, output, session) {
        output$plot1 <- renderImage({
            pathwayID <- strsplit(input$xcol, '~', fixed=TRUE)[[1]][1]
            
            outfile <- paste(directory, pathwayID, '.pathview.png', sep='')
            
            if (! file.exists(outfile)) {
                pathview(gene.data  = gene,
                    pathway.id = pathwayID,
                    species    = "hsa",
                    gene.idtype= 'ENSEMBL',
                    #limit      = list(gene=c(min(geneList),max(geneList)), 
                    #cpd=1),
                    limit      = list(gene=max(abs(gene)), cpd=1),
                    kegg.dir = directory)
                
                file.move(paste(pathwayID, '.pathview.png', sep=''), 
                    directory)
            }
            
            list(src = outfile)
        }, deleteFile = FALSE)
    }
    
    shinyApp(ui, server)
}

##' @title Parse metadata
##' @description Parse metadata either by providing the \emph{.json} 
##'     file that is downloaded from GDC cart or by parse metadata 
##'     automatically by providing the projct id and data type
##' @param metafile metadata file in \code{.json} format download 
##'     from GDC cart. If provided, the metadata will be parsed from 
##'     this file, otherwise, \code{project} and \code{data.type} arguments 
##'     should be provided to retrieve metadata automatically. 
##'     Default is \code{NULL}
##' @param project.id project id in GDC
##' @param data.type one of \code{'RNAseq'} and \code{'miRNAs'}
##' @param write.meta logical, whether to write the metadata to a 
##'     \code{.json} file
##' @importFrom rjson fromJSON
##' @importFrom jsonlite toJSON
##' @return A dataframe of metadata containing file_name, 
##'     sample_id, etc. as well as some basic clinical data
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Merge RNA expression data #######
##' metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
gdcParseMetadata <- function(metafile=NULL, project.id, 
        data.type, write.meta=FALSE) {
    
    if (! is.null(metafile)) {
        metadata <- rjson::fromJSON(file=metafile)
    } else {
        url <- gdcGetURL(project.id = project.id, data.type = data.type)
        
        metadata <- rjson::fromJSON(file=url)
        metadata <- metadata$data$hits
        #keep <- unlist(lapply(metadata$data$hits, 
        #function(sam) sam$analysis$workflow_type %in% 
        #c('HTSeq - Counts', 'BCGSC miRNA Profiling')))
        #metadata <- metadata$data$hits[keep]
        
        if (write.meta==TRUE) {
            metafile <- jsonlite::toJSON(metadata, pretty=TRUE)
            
            systime <- gsub(' ', 'T', Sys.time())
            systime <- gsub(':', '-', systime)
            
            write(metafile, file=paste(project.id, data.type, 
                'metadata', systime, 'json', sep='.'))
        }
        
    }
    
    nSam <- length(metadata)
    
    file_name <- vapply(seq_len(nSam), 
        function(i) metadata[[i]]$file_name, 
        character(1))
    file_id <- vapply(seq_len(nSam), 
        function(i) metadata[[i]]$file_id, character(1))
    submitter_id <- vapply(seq_len(nSam), function(i) 
        metadata[[i]]$cases[[1]]$samples[[1]]$submitter_id,
        character(1))
    sample <- vapply(submitter_id, 
        function(v) substr(v, 1, nchar(v)-1), 
        character(1))
    entity_submitter_id <- vapply(seq_len(nSam), function(i) 
        metadata[[i]]$associated_entities[[1]]$entity_submitter_id,
        character(1))
    sample_type <- vapply(seq_len(nSam), function(i) 
        metadata[[i]]$cases[[1]]$samples[[1]]$sample_type,
        character(1))
    patient <- vapply(seq_len(nSam), function(i) 
        metadata[[i]]$cases[[1]]$submitter_id,
        character(1))
    
    
    gender <- null2naFun(vapply(seq_len(nSam), function(i) 
        chr2naFun(metadata[[i]]$cases[[1]]$demographic$gender), character(1)))
    #race <- sapply(1:length(metadata), function(i) 
    #metadata[[i]]$cases[[1]]$demographic$race)
    #ethnicity <- sapply(1:length(metadata), function(i) 
    #metadata[[i]]$cases[[1]]$demographic$ethnicity)
    
    project_id <- vapply(seq_len(nSam), function(i) 
        chr2naFun(metadata[[i]]$cases[[1]]$project$project_id), 
        character(1))
    
    tumor_stage <- null2naFun(vapply(seq_len(nSam), function(i) 
        chr2naFun(metadata[[i]]$cases[[1]]$diagnoses[[1]]$tumor_stage), 
        character(1)))
    tumor_grade <- null2naFun(vapply(seq_len(nSam), function(i) 
        chr2naFun(metadata[[i]]$cases[[1]]$diagnoses[[1]]$tumor_grade), 
        character(1)))
    
    
    age_at_diagnosis <- suppressWarnings(vapply(seq_len(nSam), function(i) 
        num2naFun(metadata[[i]]$cases[[1]]$diagnoses[[1]]$age_at_diagnosis), 
        numeric(1)))
    days_to_death <- suppressWarnings(vapply(seq_len(nSam), function(i) 
        num2naFun(metadata[[i]]$cases[[1]]$demographic$days_to_death), 
        numeric(1)))
    days_to_last_follow_up <- suppressWarnings(vapply(seq_len(nSam), 
        function(i) num2naFun(
            metadata[[i]]$cases[[1]]$diagnoses[[1]]$days_to_last_follow_up), 
        numeric(1)))
    
    vital_status <- null2naFun(vapply(seq_len(nSam), function(i) 
        chr2naFun(metadata[[i]]$cases[[1]]$demographic$vital_status), 
        character(1)))
    
    metaMatrix <- data.frame(file_name,file_id,patient,sample,submitter_id,
        entity_submitter_id, sample_type, gender,age_at_diagnosis,tumor_stage,
        tumor_grade,days_to_death, days_to_last_follow_up,vital_status, 
        project_id, stringsAsFactors = FALSE)
    
    
    metaMatrix <- metaMatrix[order(metaMatrix$submitter_id),]
    metaMatrix[metaMatrix=='not reported'] <- NA
    metaMatrix$sample_type <- gsub(' ', '', 
        metaMatrix$sample_type, fixed=TRUE)
    metaMatrix$tumor_stage <- gsub(' ', '', 
        metaMatrix$tumor_stage, fixed=TRUE)
    
    return (metaMatrix)
}



null2naFun <- function(v) {
    v[v=='NA'] <- NA
    return (v)
}



chr2naFun <- function(v) {
    if (is.null(v)) {
        return ('NA')
    } else {
        return (as.character(v))
    }
}

num2naFun <- function(v) {
    if (is.null(v)) {
        return (NA)
    } else if (is.numeric(v)) {
        return (as.numeric(as.character(v)))
    } else {
        return (as.character(v))
    }
}

library(GDCRNATools)

context("gdcParseMetadata")

test_that("Parse metadata automatically", {
    metaMatrix <- gdcParseMetadata(project.id = 'TCGA-CHOL',
                                   data.type  = 'RNAseq', 
                                   write.meta = FALSE)
    expect_equal(unique(metaMatrix$project),"TCGA-CHOL")
})

#####################################
######     ID conversion       ######

ensembl2symbolFun <- function(ensemblID, info='symbol') {
    geneInfo <- biotype[match(ensemblID, biotype$ensemblID),]
    geneSymbol <- geneInfo$geneSymbol
    
    if (info=='symbol') {
        return (geneSymbol)
    } else if (info=='all') {
        return (geneInfo)
    }
}


symbol2ensemblFun <- function(symbol, info='ensemblID') {
    geneInfo <- biotype[match(symbol, biotype$geneSymbol),]
    ensemblID <- geneInfo$ensemblID
    
    if (info=='ensemblID') {
        return (ensemblID)
    } else if (info=='all') {
        return (geneInfo)
    }
}

##' @title Bar plot of differentially expressed genes/miRNAs
##' @description A bar plot showing the number of down-regulated and 
##'     up-regulated DE genes/miRNAs of different biotypes
##' @param deg a dataframe generated from \code{\link{gdcDEReport}} 
##'     containing DE genes/miRNAs ids, logFC, etc.
##' @param angle a numeric value specifying the angle of text on x-axis. 
##'     Default is \code{0}
##' @param data.type one of \code{'RNAseq'} and \code{'miRNAs'}
##' @return A bar plot
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000231806','ENSG00000261211','ENSG00000260920',
##'         'ENSG00000228594','ENSG00000125170','ENSG00000179909',
##'         'ENSG00000280012','ENSG00000134612','ENSG00000213071')
##' symbol <- c('PCAT7','AL031123.2','AL031985.3',
##'             'FNDC10','DOK4','ZNF154',
##'             'RPL23AP61','FOLH1B','LPAL2')
##' group <- rep(c('long_non_coding','protein_coding','pseudogene'), each=3)
##' logFC <- c(2.8,2.3,-1.1,1.9,-1.2,-1.6,1.5,2.1,-1.1)
##' FDR <- rep(c(0.1,0.00001,0.0002), each=3)
##' deg <- data.frame(symbol, group, logFC, FDR)
##' rownames(deg) <- genes
##' gdcBarPlot(deg, angle=45, data.type='RNAseq')
gdcBarPlot <- function(deg, angle=0, data.type) {

    if (data.type=='miRNAs') {
        down <- sum(deg$logFC < 0)
        up <- sum(deg$logFC > 0)
        
        d <- data.frame(geneClass = c('Up','Down'),
            geneNums = c(up, down), 
            Regulation = factor(c('Up-regulated','Down-regulated'),
            levels=c('Up-regulated','Down-regulated')))
        
        if (angle==0) {
            ggplot(data=d, aes(x=d$geneClass, y=d$geneNums, 
                fill=Regulation)) + geom_bar(stat = 'identity') + 
                scale_x_discrete(limits=d$geneClass) + 
                scale_fill_discrete(name = "") +
                ylab('No. of Differentially Expressed miRNAs') +xlab('') +
                #theme(axis.text.x = element_text(angle = angle)) + 
                theme_bw()+theme(axis.line = element_line(colour = "black"),
                    panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.border = element_rect(colour='white'),
                    panel.background = element_blank(),
                    axis.text.x = element_text(angle = angle,size=10),
                    axis.text.y=element_text(size=10))
        } else {
            ggplot(data=d, aes(x=d$geneClass, y=d$geneNums, 
                fill=Regulation)) + geom_bar(stat = 'identity') + 
                scale_x_discrete(limits=d$geneClass) + 
                scale_fill_discrete(name = "") +
                ylab('No. of Differentially Expressed miRNAs') +xlab('') +
                #theme(axis.text.x = 
                #element_text(angle = angle, vjust = 1, hjust=1)) +
                theme_bw()+theme(axis.line = element_line(colour = "black"),
                    panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.border = element_rect(colour='white'),
                    panel.background = element_blank(),
                    axis.text.x = element_text(angle = angle, vjust = 1, 
                        hjust=1,size=10),
                    axis.text.y=element_text(size=10))
        }
        
    } else if (data.type=='RNAseq') {
        gr <- list()
        for (tp in unique(deg$group)) {
            gr[[tp]][['all']] <- sum(deg$group==tp)
            gr[[tp]]['up'] <- sum(deg$group==tp & deg$logFC > 0) 
            gr[[tp]]['down'] <- sum(deg$group==tp & deg$logFC < 0)
            
        }
        
        names(gr)[names(gr) == 'protein_coding'] <- 'Protein coding'
        names(gr)[names(gr) == 'long_non_coding'] <- 'Long non-coding'
        names(gr)[names(gr) == 'pseudogene'] <- 'Pseudogene'
        names(gr)[names(gr) == 'ncRNA'] <- 'Other ncRNA'
        
        
        
        #names(gr)[names(gr) == 'IG'] <- 'Immunoglobulin gene'
        #names(gr)[names(gr) == 'TR'] <- 'T-cell receptor gene'
        #names(gr)[names(gr) == 'TEC'] <- 'To be experimentally confirmed'
        
        o <- order(unlist(lapply(gr, function(v) v[['all']])), 
            decreasing=TRUE)
        
        d <- data.frame(geneClass = rep(names(gr)[o], 2),
            geneNums = c(unlist(lapply(gr, function(v) v[['up']]))[o],
                unlist(lapply(gr, function(v) v[['down']]))[o]), 
            Regulation = factor(rep(c('Up-regulated','Down-regulated'), 
                each=length(gr)), levels=c('Up-regulated','Down-regulated')))
        
        if (angle==0) {
            ggplot(data=d, aes(x=d$geneClass, y=d$geneNums, 
                fill=Regulation)) + geom_bar(stat = 'identity') + 
                scale_x_discrete(limits=d$geneClass[seq_len(nrow(d)/2)]) + 
                scale_fill_discrete(name = "") +
                ylab('No. of Differentially Expressed Genes') +
                xlab('') +
                #theme(axis.text.x = element_text(angle = angle)) +
                theme_bw()+theme(axis.line = element_line(colour = "black"),
                    panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.border = element_rect(colour='white'),
                    panel.background = element_blank(),
                    axis.text.x = element_text(angle = angle,size=14),
                    axis.text.y=element_text(size=14))
        } else {
            ggplot(data=d, aes(x=d$geneClass, y=d$geneNums, 
                fill=Regulation)) + geom_bar(stat = 'identity') + 
                scale_x_discrete(limits=d$geneClass[seq_len(nrow(d)/2)]) + 
                scale_fill_discrete(name = "") +
                ylab('No. of Differentially Expressed Genes') +
                xlab('') +
                #theme(axis.text.x = 
                #element_text(angle = angle, vjust = 1, hjust=1)) +
                theme_bw()+theme(axis.line = element_line(colour = "black"),
                    panel.grid.major = element_blank(),
                    panel.grid.minor = element_blank(),
                    panel.border = element_rect(colour='white'),
                    panel.background = element_blank(),
                    axis.text.x = element_text(angle = angle, vjust = 1, 
                        hjust=1,size=14),
                    axis.text.y=element_text(size=14)) +
                theme(axis.title=element_text(size=16), 
                    legend.text = element_text(size=14))
        }
    }
}



##' @title Volcano plot of differentially expressed genes/miRNAs
##' @description A volcano plot showing differentially expressed genes/miRNAs
##' @param deg.all a dataframe generated from \code{\link{gdcDEAnalysis}} 
##'     containing all genes of analysis no matter they are differentially 
##'     expressed or not
##' @param fc a numeric value specifying the threshold of fold change
##' @param pval a nuemric value specifying the threshold of p value
##' @return A volcano plot
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000231806','ENSG00000261211','ENSG00000260920',
##'         'ENSG00000228594','ENSG00000125170','ENSG00000179909',
##'         'ENSG00000280012','ENSG00000134612','ENSG00000213071')
##' symbol <- c('PCAT7','AL031123.2','AL031985.3',
##'             'FNDC10','DOK4','ZNF154',
##'             'RPL23AP61','FOLH1B','LPAL2')
##' group <- rep(c('long_non_coding','protein_coding','pseudogene'), each=3)
##' logFC <- c(2.8,2.3,-1.1,1.9,-1.2,-1.6,1.5,2.1,-1.1)
##' FDR <- rep(c(0.1,0.00001,0.0002), each=3)
##' deg <- data.frame(symbol, group, logFC, FDR)
##' rownames(deg) <- genes
##' gdcVolcanoPlot(deg.all=deg)
gdcVolcanoPlot <- function(deg.all, fc=2, pval=0.01) {
    geneList <- deg.all
    geneList$threshold <- c()
    geneList$threshold[geneList$logFC>log(fc,2) & geneList$FDR<pval] <- 1
    geneList$threshold[geneList$logFC>=-log(fc,2) & geneList$logFC<=log(fc,2) 
        | geneList$FDR>=pval] <- 2
    geneList$threshold[geneList$logFC < -log(fc,2) & geneList$FDR<pval] <- 3
    
    geneList$threshold <- as.factor(geneList$threshold)
    
    lim <- max(max(geneList$logFC), abs(min(geneList$logFC)))+0.5
    
    volcano <- ggplot(data=geneList, aes(x=geneList$logFC, 
        y = -log10(geneList$FDR)))
    volcano+geom_point(aes(color=geneList$threshold), alpha=1, size=0.8) + 
        xlab("log2(Fold Change)") + ylab("-log10(FDR)") +
        scale_colour_manual(breaks = geneList$threshold, 
            values = c('red','black','green3')) + xlim(c(-lim,lim)) +
        geom_vline(xintercept = c(-log(fc,2),log(fc,2)), 
            color='darkgreen', linetype=3) + 
        geom_hline(yintercept = -log(pval,10), color='darkgreen',linetype=3)+
        theme_bw() +
        theme(axis.line = element_line(colour = "black"),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.border = element_rect(colour='black'),
            panel.background = element_blank()) +
        theme(legend.position="none") +
        theme(axis.text=element_text(size=14), 
            axis.title=element_text(size=16))
}



##' @title Heatmap of differentially expressed genes/miRNAs
##' @description A heatmap showing unsupervised hierarchical clustering of 
##'     DE genes/miRNAs by \code{\link[gplots]{heatmap.2}} in the 
##'     \pkg{gplots} package
##' @param deg.id a vector of Ensembl gene ids or miRBase v21 mature miRNA ids
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @importFrom gplots heatmap.2
##' @importFrom gplots colorpanel
##' @importFrom gplots bluered
##' @return A heatmap with rows are DE genes/miRNAs and columns are samples.
##'     \emph{Solid Tissue Normal} samples are labeled with blue and 
##'     \emph{Primary Tumor} samples are labeled with red
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'              'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' gdcHeatmap(deg.id=genes, metadata=metaMatrix, rna.expr=rnaExpr)
gdcHeatmap <- function(deg.id, metadata, rna.expr) {

    degDa <- rna.expr[deg.id,]
    
    sampleCol <- ifelse(metadata$sample_type=='SolidTissueNormal', 
        'blue', 'red')
    #col=colorpanel(75,"darkblue","white","orangered")
    lmat = rbind(c(4,3),c(2,1))
    lwid = c(2,4)
    lhei = c(1,5)
    
    heatmap.2(as.matrix(degDa), col=bluered(75), trace='none', 
        cexCol=0.32, cexRow=0.1,dendrogram='both', srtCol=90, 
        adjCol=c(0.8,0.15), density.info="none", labRow=NA,
        key.title=NA,na.color=NA,lwid=lwid, lhei=lhei,  
        margins =c(3,3), labCol=NA, key.xlab='Normalized intensity', 
        scale='row', ColSideColors = sampleCol)
}

##' @title Kaplan Meier plot
##' @description Plot Kaplan Meier survival curve
##' @param gene an Ensembl gene id
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @param sep a character string specifying which point should be used to 
##'     separate low-expression and high-expression groups. Possible values 
##'     are \code{'1stQu'}, \code{'mean'}, \code{'median'}, 
##'     and \code{'3rdQu'}. Default is \code{'median'} 
##' @importFrom survival survfit
##' @importFrom survival survdiff
##' @importFrom survminer ggsurvplot
##' @return A plot of Kaplan Meier survival curve
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### KM plots #######
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' gdcKMPlot(gene='ENSG00000000938', rna.expr=rnaExpr, 
##'     metadata=metaMatrix, sep='median')
gdcKMPlot <- function(gene, rna.expr, metadata, sep='median') {
    
    metadata <- metadata[metadata$sample_type=='PrimaryTumor',]
    
    samples = intersect(colnames(rna.expr), metadata$sample)
    
    exprDa=rna.expr[gene,samples]
    
    
    if (sep=='1stQu') {
        thresh <- as.numeric(summary(exprDa)[2])
    } else if (sep=='median') {
        thresh <- as.numeric(summary(exprDa)[3])
    } else if (sep=='mean') {
        thresh <- as.numeric(summary(exprDa)[4])
    } else if (sep=='3rdQu') {
        thresh <- as.numeric(summary(exprDa)[5])
    }
    
    exprGroup <- exprDa > thresh
    
    nH <- sum(exprGroup)
    nL <- sum(!exprGroup)
    
    clinicalDa=metadata[match(samples,metadata$sample),]
    
    daysToDeath <- as.numeric(clinicalDa$days_to_death)
    nonComplt <- is.na(daysToDeath)
    
    vitalStatus <- as.numeric(ifelse(nonComplt, 0, 1))
    daysToDeath[nonComplt] <- 
        as.numeric(clinicalDa$days_to_last_follow_up[nonComplt])
    
    survDa <- data.frame(daysToDeath,vitalStatus, exprGroup)
    
    sdf <- survdiff(Surv(daysToDeath, vitalStatus) ~ exprGroup)
    pValue <- format(pchisq(sdf$chisq, length(sdf$n)-1, 
                            lower.tail = FALSE),digits=3)
    #pValue <- format(1-pchisq(sdf$chisq, df=1),digits=3)
    
    HR = (sdf$obs[2]/sdf$exp[2])/(sdf$obs[1]/sdf$exp[1])
    upper95 = exp(log(HR) + qnorm(0.975)*sqrt(1/sdf$exp[2]+1/sdf$exp[1]))
    lower95 = exp(log(HR) - qnorm(0.975)*sqrt(1/sdf$exp[2]+1/sdf$exp[1]))
    
    HR <- format(HR, digits = 3)
    upper95 <- format(upper95, digits = 3)
    lower95 <- format(lower95, digits = 3)
    
    
    label1 <- paste('HR = ', HR, ' (', lower95, '-', upper95, ')', sep='')
    label2 <- paste('logrank P value = ', pValue, sep='')
    
    fit <- survfit(Surv(daysToDeath, vitalStatus) ~ exprGroup, data=survDa)
    
    lgdXpos <- 1/1.3
    lgdYpos = 0.9
    
    xpos = max(daysToDeath, na.rm=TRUE)/1.8
    ypos1 = 0.8
    
    ypos2 = 0.75
    
    ggsurvplot(fit, data=survDa, pval = paste(label1, '\n', label2), pval.coord = c(xpos, ypos1),
               pval.size=5,
               font.main = c(16, 'bold', 'black'), conf.int = FALSE, 
               #title = project,
               legend = c(lgdXpos, lgdYpos), 
               #color = c('blue', 'green'),
               palette= c('blue', 'red'),
               legend.labs = c(paste('lowExp (N=',nL,')',sep=''), 
                               paste('highExp  (N=',nH,')',sep='')),  
               legend.title='group',
               xlab = paste('Overall survival (days)'), ylab = 'Survival probability',
               #xlab = paste(type,'(months)'), ylab = 'Survival probability',
               font.x = c(16), font.y = c(16), ylim=c(0,1), #16
               ggtheme = theme_bw()+ theme(axis.line = element_line(colour = "black"),
                                           panel.grid.major = element_blank(),
                                           panel.grid.minor = element_blank(),
                                           #panel.border = element_rect(colour='black'),
                                           panel.border = element_blank(),
                                           panel.background = element_blank(),
                                           legend.text = element_text(size=12),#14
                                           legend.title = element_text(size=14),
                                           axis.text = element_text(size=14, color='black'))) #+
    #ggplot2::annotate("text", x = xpos, y = ypos1,
    #                  label = label1, size = 5) + #5.2
    #ggplot2::annotate("text", x = xpos, y = ypos2,
    #                  label = label2, size = 5)
    #ggplot2::geom_text(x = xpos, y = ypos1,label = label1, size=5)
    
}

##' @title Export network for Cytoscape
##' @description Export nodes and edges of ce network for 
##'     \strong{Cytoscape} visualization
##' @param ceNetwork a dataframe generated from \code{\link{gdcCEAnalysis}}
##' @param net one of \code{'nodes'} and \code{'edges'}
##' @return A dataframe of nodes or edges
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### ceRNA network analysis #######
##' ceOutput <- data.frame(lncRNAs=c('ENSG00000242125','ENSG00000242125',
##'                                 'ENSG00000245532'), 
##'                     Genes=c('ENSG00000043355','ENSG00000109586',
##'                                 'ENSG00000144355'), 
##'                     miRNAs=c('hsa-miR-340-5p','hsa-miR-340-5p',
##'                             'hsa-miR-320b,hsa-miR-320d,
##'                             hsa-miR-320c,hsa-miR-320a'),
##'                     Counts=c(1,1,4), stringsAsFactors=FALSE)
##' ####### Export edges #######
##' edges <- gdcExportNetwork(ceNetwork=ceOutput, net='edges')
##' 
##' ####### Export nodes #######
##' \dontrun{nodes <- gdcExportNetwork(ceNetwork=ceOutput, net='nodes')}
gdcExportNetwork <- function(ceNetwork, net) {

    mirs <- unlist(strsplit(ceNetwork$miRNAs, ',', fixed=TRUE))
    
    fromNode <- rep(c(ceNetwork$lncRNAs,ceNetwork$Genes), 
        times=rep(as.numeric(ceNetwork$Counts),2))
    toNode <- rep(mirs, 2)
    altNode1Name <- ensembl2symbolFun(fromNode)
    edges <- data.frame(fromNode, toNode, altNode1Name, 
        stringsAsFactors = FALSE)
    
    #filter <- duplicated(edges)
    #edges <- edges[-filter,]
    edges <- unique(edges)
    
    nodeTable1 <- table(edges$fromNode)
    nodeTable2 <- table(edges$toNode)
    
    symbol <- c(ensembl2symbolFun(names(nodeTable1)), names(nodeTable2))
    
    type <- c(ifelse(names(nodeTable1) %in% ceNetwork$lncRNAs, 'lnc', 'pc'), 
        rep('mir', length(nodeTable2)))
    
    
    nodes <- data.frame(gene=c(names(nodeTable1), names(nodeTable2)), 
        symbol, type, numInteractions=as.numeric(c(nodeTable1, nodeTable2)))
    
    if (net=='nodes') {
        return (nodes)
    } else if (net=='edges') {
        return (edges)
    }
}

##' @title Differential gene expression analysis
##' @description Performs differential gene expression analysis by 
##'     \pkg{limma}, \pkg{edgeR}, and \pkg{DESeq2}
##' @param counts a dataframe or numeric matrix of raw counts data generated 
##'     from \code{\link{gdcRNAMerge}}
##' @param group a vector giving the group that each sample belongs to
##' @param comparison a character string specifying the two groups 
##'     being compared. \cr
##'     Example: \code{comparison='PrimaryTumor-SolidTissueNormal'}
##' @param method one of \code{'limma'}, \code{'edgeR'}, and 
##'     \code{'DESeq2'}. Default is \code{'limma'} \cr
##'     Note: It may takes long time for \code{method='DESeq2'} 
##'     with a single core
##' @param n.cores a numeric value of cores to be used for 
##'     \code{method='DESeq2'} to accelate the analysis process. 
##'     Default is \code{NULL}
##' @param filter logical, whether to filter out low expression genes. 
##'     If \code{TRUE}, only genes 
##'     with \code{cpm > 1} in more than half of the samples will be kept. 
##'     Default is \code{TRUE}
##' @import edgeR
##' @importFrom limma makeContrasts
##' @importFrom limma voom
##' @importFrom limma lmFit
##' @importFrom limma contrasts.fit
##' @importFrom limma eBayes
##' @importFrom limma topTable
##' @importFrom DESeq2 DESeqDataSetFromMatrix
##' @importFrom DESeq2 DESeq
##' @importFrom DESeq2 results
##' @importFrom BiocParallel MulticoreParam
##' @importFrom BiocParallel register
##' @return A dataframe containing Ensembl gene ids/miRBase v21 mature 
##'     miRNA ids, gene symbols, biotypes, fold change on the log2 scale, 
##'     p value, and FDR etc. of all genes/miRNAs of analysis.
##' @note It may takes long time for \code{method='DESeq2'} with a 
##'     single core. Please use multiple cores if possible
##' @references
##'     Robinson MD, McCarthy DJ, Smyth GK. edgeR: a Bioconductor package 
##'     for differential expression analysis of digital gene expression data. 
##'     Bioinformatics. 2010 Jan 1;26(1):139-40. \cr
##'     Ritchie ME, Phipson B, Wu D, Hu Y, Law CW, Shi W, Smyth GK. 
##'     limma powers differential expression analyses for RNA-sequencing and 
##'     microarray studies. Nucleic acids research. 2015 Jan 20;
##'     43(7):e47-e47. \cr
##'     Love MI, Huber W, Anders S. Moderated estimation of fold change and 
##'     dispersion for RNA-seq data with DESeq2. Genome biology. 2014 Dec 5;
##'     15(12):550.
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-11', 
##'             'TCGA-2F-A9KT-11', 'TCGA-2F-A9KW-11')
##' 
##' metaMatrix <- data.frame(sample_type=rep(c('PrimaryTumor',
##'                     'SolidTissueNormal'),each=3),
##'                     sample=samples,
##'                     days_to_death=seq(100,600,100),
##'                     days_to_last_follow_up=rep(NA,6))
##' rnaMatrix <- matrix(c(6092,11652,5426,4383,3334,2656,
##'                     8436,2547,7943,3741,6302,13976,
##'                     1506,6467,5324,3651,1566,2780,
##'                     834,4623,10275,5639,6183,4548,
##'                     24702,43,1987,269,3322,2410,
##'                     2815,2089,3804,230,883,5415), 6,6)
##' rownames(rnaMatrix) <- genes
##' colnames(rnaMatrix) <- samples
##' DEGAll <- gdcDEAnalysis(counts     = rnaMatrix, 
##'                         group      = metaMatrix$sample_type, 
##'                         comparison = 'PrimaryTumor-SolidTissueNormal', 
##'                         method     = 'limma')
gdcDEAnalysis <- function(counts, group, comparison, method='limma', 
    n.cores=NULL, filter=TRUE) {
    dge = DGEList(counts = counts)
    keep <- rowSums(cpm(dge) > 1) >= 0.5*length(group)
    
    if (method == 'DESeq2') {
        
        message ('DE analysis using DESeq2 may take', 
            'long time with a single core\n')
        
        coldata <- data.frame(group)
        dds <- DESeqDataSetFromMatrix(countData = counts,
            colData = coldata, design = ~ group)
        
        dds$group <- factor(dds$group, levels = 
            rev(strsplit(comparison, '-', fixed=TRUE)[[1]]))
        
        if (filter==TRUE) {
            dds <- dds[keep, ]
        }
        
        if (! is.null(n.cores)) {
            register(MulticoreParam(n.cores))
            dds <- DESeq(dds, parallel=TRUE)
        } else {
            dds <- DESeq(dds)
        }
        
        res <- results(dds)
        #res <- lfcShrink(dds, coef=2, res=res)
        
        DEGAll <- data.frame(res)
        colnames(DEGAll) <- c('baseMean', 'logFC', 'lfcSE', 'stat', 
            'PValue', 'FDR')
        
    } else if (method %in% c('edgeR', 'limma')) {
        group <- factor(group)
        design <- model.matrix(~0+group)
        colnames(design) <- levels(group)
        contrast.matrix <- makeContrasts(contrasts=comparison, 
            levels=design)
        
        if (filter==TRUE) {
            dge <- dge[keep,,keep.lib.sizes = TRUE]
        }
        dge <- calcNormFactors(dge)
        
        if (method == 'edgeR') {
            dge <- estimateDisp(dge, design)
            fit <- glmFit(dge, design)
            lrt <- glmLRT(fit, contrast=contrast.matrix)
            
            DEGAll <- lrt$table
            
        } else if (method == 'limma') {
            v <- voom(dge, design=design, plot = FALSE)
            
            fit <- lmFit(v, design)
            fit2 <- contrasts.fit(fit, contrast.matrix)
            fit2 <- eBayes(fit2)
            
            DEGAll <- topTable(fit2, coef=1, n = Inf)
            colnames(DEGAll) <- c('logFC', 'AveExpr', 't', 
                'PValue', 'FDR', 'B')
        }
    }
    
    DEGAll$FDR <- p.adjust(DEGAll$PValue, method = 'fdr')
    o <- order(DEGAll$FDR)
    DEGAll <- DEGAll[o,]
    
    if (startsWith(rownames(counts)[1], 'ENSG')) {
        degList <- biotype[match(rownames(DEGAll), biotype$ensemblID),]
        degOutput <- data.frame(symbol=degList$geneSymbol, 
            group=degList$group, DEGAll)
        
        keep <- which(! is.na(degOutput$symbol))
        degOutput <- degOutput[keep,]
        return(degOutput)
    } else {
        return (DEGAll)
    }
}


###
deAnalysislimma <- function(v, design, contrast.matrix, type='RNAseq') {
    fit <- lmFit(v, design)
    fit2 <- contrasts.fit(fit, contrast.matrix)
    fit2 <- eBayes(fit2)
    
    DEGAll <- topTable(fit2, coef=1, n = Inf)
    
    o <- order(DEGAll$adj.P.Val)
    DEGAll <- DEGAll[o,]
    
    if (type=='miRNAs') {
        return (DEGAll)
    } else {
        degList <- biotype[match(rownames(DEGAll), biotype$ensemblID),]
        degOutput <- data.frame(symbol=degList$geneSymbol, 
            group=degList$group, DEGAll)
        
        keep <- which(! is.na(degOutput$symbol))
        
        degOutput <- degOutput[keep,]
        return(degOutput)
    }
}


##' @title Report differentially expressed genes/miRNAs
##' @description Report genes/miRNAs that are differentially expressed 
##'     satisfying a given threshold
##' @param deg A dataframe of DE analysis result from 
##'     \code{\link{gdcDEAnalysis}}
##' @param gene.type one of \code{'all'}, \code{'long_non_coding'}, 
##'     \code{'protein_coding'}, and \code{'miRNAs'}. Default is \code{'all'}
##' @param fc a numeric value specifying the threshold of fold change
##' @param pval a nuemric value specifying the threshold of p value
##' @return A dataframe or numeric matrix of differentially expressed 
##'     genes/miRNAs
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-11',
##'              'TCGA-2F-A9KT-11', 'TCGA-2F-A9KW-11')
##'              
##' metaMatrix <- data.frame(sample_type=rep(c('PrimaryTumor',
##'                         'SolidTissueNormal'),each=3),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaMatrix <- matrix(c(6092,11652,5426,4383,3334,2656,
##'                     8436,2547,7943,3741,6302,13976,
##'                     1506,6467,5324,3651,1566,2780,
##'                     834,4623,10275,5639,6183,4548,
##'                     24702,43,1987,269,3322,2410,
##'                     2815,2089,3804,230,883,5415), 6,6)
##' rownames(rnaMatrix) <- genes
##' colnames(rnaMatrix) <- samples
##' DEGAll <- gdcDEAnalysis(counts     = rnaMatrix, 
##'                         group      = metaMatrix$sample_type, 
##'                         comparison = 'PrimaryTumor-SolidTissueNormal', 
##'                         method     = 'limma')
##' dePC <- gdcDEReport(deg=DEGAll)
gdcDEReport <- function(deg, gene.type='all', fc=2, pval=0.01) {
    sig <- abs(deg$logFC)>log(fc,2) & deg$FDR<pval
    
    degFinal <- deg[sig,]
    
    if (gene.type=='all' | gene.type=='miRNAs') {
        return (degFinal)
    } else {
        keep <- degFinal$group == gene.type
        degFinal <- degFinal[keep,]
        return (degFinal)
    }
}

##' @title Functional enrichment analysis
##' @description Performs Gene Ontology (GO), Kyoto Encyclopedia of Genes 
##'     and Genomes (KEGG) pathway and Disease Ontology (DO) enrichment 
##'     analyses by \pkg{clusterProfiler} and \pkg{DOSE} packages
##' @param gene a vector of Ensembl gene id
##' @param simplify logical, specifying whether to remove redundant GO terms. 
##'     Default \code{simplify=TRUE}
##' @param level a numeric value, restrict the GO enrichment result at a 
##'     specific GO level. Default is \code{0}, which means all terms 
##'     should be returned
##' @importFrom clusterProfiler enrichGO
##' @importFrom clusterProfiler gofilter
##' @importFrom clusterProfiler simplify
##' @importFrom clusterProfiler enrichKEGG
##' @import org.Hs.eg.db
##' @importFrom DOSE enrichDO
##' @importFrom biomaRt useMart
##' @importFrom biomaRt getBM
##' @return A dataframe of enrichment analysis result containing 
##'     enriched terms, number of overlpped genes, p value of 
##'     hypergeometric test, fdr, fold of enrichment, Ensembl gene ids, 
##'     gene symbols, and functional categories, etc.
##' @references
##'     Yu G, Wang LG, Han Y, He QY. clusterProfiler: an R package for 
##'     comparing biological themes among gene clusters. 
##'     Omics: a journal of integrative biology. 2012 May 1;16(5):284-7. \cr
##'     Yu G, Wang LG, Yan GR, He QY. DOSE: an R/Bioconductor package for 
##'     disease ontology semantic and enrichment analysis. Bioinformatics. 
##'     2014 Oct 17;31(4):608-9.
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### GO, KEGG, DO enrichment analysis #######
##' deg <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' \dontrun{enrichOutput <- gdcEnrichAnalysis(gene=deg, simplify=TRUE)}
gdcEnrichAnalysis <- function(gene, simplify=TRUE, level=0) {

    message ('### This step may take a few minutes ###\n')
    
    goBP <- enrichGO(gene = gene,
        universe = biotype$ensemblID,
        OrgDb = org.Hs.eg.db,
        ont = "BP",
        keyType = 'ENSEMBL',
        pAdjustMethod = "fdr",
        pvalueCutoff = 0.01,
        readable = FALSE)
    
    if (level != 0) {
        goBP <- gofilter(goBP, level=level)
    }
    
    if (simplify==TRUE) {
        goBP <- simplify(goBP, cutoff=0.7, by="p.adjust", select_fun=min)
    }
    
    message ('Step 1/5: BP analysis done!')
    
    goCC <- enrichGO(gene = gene,
        universe = biotype$ensemblID,
        OrgDb = org.Hs.eg.db,
        ont = "CC",
        keyType = 'ENSEMBL',
        pAdjustMethod = "fdr",
        pvalueCutoff = 0.01,
        readable = FALSE)
    
    if (level != 0) {
        goCC <- gofilter(goCC, level=level)
    }
    
    if (simplify==TRUE) {
        goCC <- simplify(goCC, cutoff=0.7, by="p.adjust", select_fun=min)
    }
    
    message ('Step 2/5: CC analysis done!')
    
    goMF <- enrichGO(gene = gene,
        universe = biotype$ensemblID,
        OrgDb = org.Hs.eg.db,
        ont = "MF",
        keyType = 'ENSEMBL',
        pAdjustMethod = "fdr",
        pvalueCutoff = 0.01,
        readable = FALSE)
    
    if (level != 0) {
        goMF <- gofilter(goMF, level=level)
    }
    
    if (simplify==TRUE) {
        goMF <- simplify(goMF, cutoff=0.7, by="p.adjust", select_fun=min)
    }
    
    message ('Step 3/5: MF analysis done!')
    
    genes <- biotype[match(gene, biotype$ensemblID),]
    genes <- genes[! is.na(genes$entrezgene),]
    universe <- biotype[!is.na(biotype$entrezgene),]
    
    #ensembl = useMart("ensembl",dataset="hsapiens_gene_ensembl")
    #genes <- getBM(attributes = c('ensembl_gene_id','entrezgene'), 
    #    values=gene, filters='ensembl_gene_id', mart=ensembl)
    #genes <- genes[! is.na(genes$entrezgene),]
    #universe <- getBM(attributes = c('ensembl_gene_id','entrezgene'), 
    #    values=biotype$ensemblID, filters='ensembl_gene_id', mart=ensembl)
    
    kegg <- enrichKEGG(gene = as.character(genes$entrezgene),
        organism = 'hsa',
        universe = as.character(unique(
            universe$entrezgene[!is.na(universe$entrezgene)])),
        minGSSize = 10,
        maxGSSize = 500,
        pAdjustMethod = 'fdr',
        pvalueCutoff = 0.01)
    
    kegg <- data.frame(kegg@result)
    
    kegg$geneID <- unlist(lapply(kegg$geneID, function(v) 
        paste(genes$ensembl_gene_id[match(strsplit(v, '/', fixed=TRUE)[[1]],
            genes$entrezgene)], collapse = '/')))
    
    message ('Step 4/5: KEGG analysis done!')
    
    do <- enrichDO(gene = as.character(genes$entrezgene),
        universe = as.character(unique(
            universe$entrezgene[!is.na(universe$entrezgene)])),
        ont = "DO",
        pAdjustMethod = "fdr",
        pvalueCutoff = 0.01,
        readable = FALSE)
    
    do <- data.frame(do@result)
    
    do$geneID <- unlist(lapply(do$geneID, function(v) 
        paste(genes$ensembl_gene_id[match(strsplit(v, '/', fixed=TRUE)[[1]], 
            genes$entrezgene)], collapse = '/')))
    
    message ('Step 5/5: DO analysis done!')
    
    goBP <- organizeEnrichFun(data.frame(goBP@result))
    goCC <- organizeEnrichFun(data.frame(goCC@result))
    goMF <- organizeEnrichFun(data.frame(goMF@result))
    kegg <- organizeEnrichFun(kegg)
    do   <- organizeEnrichFun(do)
    
    enrichOutput <- data.frame(rbind(goBP, goCC, goMF, kegg, do))
    
    enrichOutput$Category <- rep(c('GO_BP','GO_CC','GO_MF','KEGG', 'DO'), 
        c(nrow(goBP),nrow(goCC),nrow(goMF),nrow(kegg),nrow(do)))
    
    return (enrichOutput)
}


###
organizeEnrichFun <- function(go) {

    Terms <- paste(go$ID, go$Description, sep='~')
    Counts <- go$Count
    
    GeneRatio <- go$GeneRatio
    BgRatio <- go$BgRatio
    
    pValue <- go$pvalue
    FDR <- go$p.adjust
    
    listTotal <- vapply(go$GeneRatio, function(v) 
        convertRatioFun(v, type='bg'), numeric(1))
    popHits <- vapply(go$BgRatio, function(v) 
        convertRatioFun(v, type='hit'), numeric(1))
    popTotal <- vapply(go$BgRatio, function(v) 
        convertRatioFun(v, type='bg'), numeric(1))
    
    foldEnrichment <- as.vector(Counts/listTotal*popTotal/popHits)
    
    geneID <- go$geneID
    geneSymbol <- unlist(lapply(strsplit(geneID, '/', fixed=TRUE), 
        function(v) paste(ensembl2symbolFun(v), collapse = '/')))
    
    goOutput <- data.frame(Terms, Counts, GeneRatio, BgRatio, pValue, FDR, 
        foldEnrichment, geneID, geneSymbol)
    
    return (goOutput)
}


###
convertRatioFun <- function(v, type='bg') {
    ratio <- strsplit(v, '/', fixed=TRUE)
    
    if (type=='bg') {
        num <- as.numeric(as.character(ratio[[1]][2]))
    } else if (type=='hit') {
        num <- as.numeric(as.character(ratio[[1]][1]))
    }
    
    return (num)
}

##' @title Download RNA data in GDC
##' @description Download gene expression quantification 
##'     and isoform expression quantification data from GDC 
##'     either by providing the manifest file or by sepcifying 
##'     the project id and data type
##' @param manifest menifest file that is downloaded from the GDC cart. 
##'     If provided, files whose UUIDs are in the manifest file 
##'     will be downloaded via gdc-client, otherwise, \code{project} and 
##'     \code{data.type} arguments should be provided to download 
##'     data automatically. Default is \code{NULL}
##' @param project.id project id in GDC
##' @param data.type one of \code{'RNAseq'} and \code{'miRNAs'}
##' @param directory the folder to save downloaded files. 
##'     Default is \code{'Data'}
##' @param write.manifest logical, whether to write out the manifest file
##' @param method method that is used to download data. Either 
##'     \code{'GenomicDataCommons'} which is a well established method 
##'     developed in the \pkg{GenomicDataCommons'} package, or alternatively 
##'     \code{'gdc-client'} which uses the \code{gdc-client} tool developed 
##'     by GDC. Default is \code{'gdc-client'}.
##' @importFrom GenomicDataCommons gdcdata
##' @importFrom DT datatable
##' @return Downloaded files in the specified directory
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Download RNA data by menifest file #######
##' manifest <- 'RNAseq.manifest.txt'
##' \dontrun{gdcRNADownload(manifest=manifest)}
##'
##' ####### Download RNA data by project id and data type #######
##' project <- 'TCGA-PRAD'
##' \dontrun{gdcRNADownload(project.id=project, data.type='RNAseq')}
gdcRNADownload <- function(manifest=NULL, project.id, data.type, 
    directory='Data', write.manifest=FALSE, method='gdc-client') {

    if (! is.null(manifest)) {
        manifestDownloadFun(manifest=manifest,directory=directory)
        
    } else {
        
        url <- gdcGetURL(project.id=project.id, data.type=data.type)
        manifest <- read.table(paste(url, '&return_type=manifest', sep=''), 
            header=TRUE, stringsAsFactors=FALSE)
        
        systime <- gsub(' ', 'T', Sys.time())
        systime <- gsub(':', '-', systime)
        
        manifile <- paste(project.id, data.type, 'gdc_manifest', 
            systime, 'txt', sep='.')
        write.table(manifest, file=manifile, row.names=FALSE, 
            sep='\t', quote=FALSE)
        
        if (method=='GenomicDataCommons') {
            ex <- manifest$filename %in% dir(directory)
            nonex <- ! ex
            numFiles <- sum(ex)
            
            if(numFiles > 0) {
                message (paste('Already exists',numFiles,'files !',sep=' '))
                
                if (sum(nonex) > 0 ) {
                    message (paste('Download the other', 
                        sum(nonex), 'files !', sep=' '))
                    manifest <- manifest[nonex,]
                    fnames = lapply(manifest$id,gdcdata,
                        destination_dir=directory,overwrite=TRUE,
                        progress=TRUE)
                } else {
                    return(invisible())
                }
                
            } else {
                fnames = lapply(manifest$id,gdcdata,
                    destination_dir=directory,overwrite=TRUE,
                    progress=TRUE)
            }
            
        } else if (method=='gdc-client') {
            manifestDownloadFun(manifest=manifile,directory=directory)
        }
        
        if (write.manifest == FALSE) {
            invisible(file.remove(manifile))
        }
    }
}



###
downloadClientFun <- function(os) {
    if (os == 'Linux') {
        adress <- paste('https://gdc.cancer.gov/files/public/file/',
            'gdc-client_v1.6.0_Ubuntu_x64-py3.7_0.zip',
            sep='')
        download.file(adress, 
            destfile = './gdc-client_v1.6.0_Ubuntu_x64-py3.7_0.zip')
        unzip('./gdc-client_v1.6.0_Ubuntu_x64-py3.7_0.zip')
        
    } else if ( os== 'Windows') {
        adress <- paste('https://gdc.cancer.gov/files/public/file/',
            'gdc-client_v1.6.0_Windows_x64-py3.7_0.zip',
            sep='')
        download.file(adress, 
            destfile = './gdc-client_v1.6.0_Windows_x64-py3.7_0.zip')
        unzip('./gdc-client_v1.6.0_Windows_x64-py3.7_0.zip')
        
    } else if (os == 'Darwin') {
        adress <- paste('https://gdc.cancer.gov/files/public/file/',
            'gdc-client_v1.6.0_OSX_x64_1.zip',
            sep='')
        download.file(adress, destfile = './gdc-client_v1.6.0_OSX_x64_1.zip')
        unzip('./gdc-client_v1.6.0_OSX_x64_1.zip')
    }
}


###
manifestDownloadFun <- function(manifest=manifest,directory) {

    ### download gdc-client
    if (! file.exists('gdc-client') & !file.exists('gdc-client.exe')) {
        downloadClientFun(Sys.info()[1])
    }
    
    Sys.chmod('gdc-client')
    
    manifestDa <- read.table(manifest, sep='\t', header=TRUE, 
        stringsAsFactors = FALSE)
    ex <- manifestDa$filename %in% dir(paste(directory, 
        dir(directory), sep='/'))
    nonex <- ! ex
    numFiles <- sum(ex)
    
    if(numFiles > 0) {
        message (paste('Already exists', numFiles, 'files !', sep=' '))
        
        if (sum(nonex) > 0 ) {
            message (paste('Download the other', 
                sum(nonex), 'files !', sep=' '))
            
            manifestDa <- manifestDa[nonex,]
            manifest <- paste(manifestDa$id, collapse =' ')
            system(paste('./gdc-client download ', manifest, sep=''))
        } else {
            return(invisible())
        }
        
        
    } else {
        system(paste('./gdc-client download -m ', manifest, sep=''))
    }
    
    
    #### move to the directory
    files <- manifestDa$id
    if (directory == 'Data') {
        if (! dir.exists('Data')) {
            dir.create('Data')
        }
    } else {
        if (! dir.exists(directory)) {
            dir.create(directory, recursive = TRUE)
        }
    }
    
    file.move(files, directory)
}


###
file.move <- function(files, directory) {
    file.copy(from=files, to=directory, recursive = TRUE)
    unlink(files, recursive=TRUE)
}


##############
gdcGetURL <- function(project.id, data.type) {
    urlAPI <- 'https://api.gdc.cancer.gov/files?'
    
    if (data.type=='RNAseq') {
        data.category <- 'Transcriptome Profiling'
        data.type <- 'Gene Expression Quantification'
        #workflow.type <- 'HTSeq - Counts'
	workflow.type <- 'STAR - Counts'
    } else if (data.type=='miRNAs') {
        data.category <- 'Transcriptome Profiling'
        data.type <- 'Isoform Expression Quantification'
        workflow.type <- 'BCGSC miRNA Profiling'
    } else if (data.type=='Clinical') {
        data.category <- 'Clinical'
        data.type <- 'Clinical Supplement'
        workflow.type <- NA
    } else if (data.type=='pre-miRNAs') {
        data.category <- 'Transcriptome Profiling'
        data.type <- 'miRNA Expression Quantification'
        workflow.type <- 'BCGSC miRNA Profiling'
    }
    
    project <- paste('{"op":"in","content":{"field":"cases.',
        'project.project_id","value":["', 
        project.id, '"]}}', sep='')
    dataCategory <- paste('{"op":"in","content":{"field":"files.', 
        'data_category","value":"', data.category, '"}}', sep='')
    dataType <- paste('{"op":"in","content":{"field":"files.data_type",',
        '"value":"', data.type, '"}}', sep='')
    workflowType <- paste('{"op":"in","content":{"field":"files.',
        'analysis.workflow_type","value":"', workflow.type, '"}}', sep='')
    
    
    if (is.na(workflow.type)) {
        dataFormat <- paste('{"op":"in","content":{"field":"files.',
            'data_format","value":"', 'BCR XML', '"}}', sep='')
        content <- paste(project, dataCategory, dataType, dataFormat, sep=',')
    } else {
        content <- paste(project, dataCategory, dataType, 
            workflowType, sep=',')
    }
    
    filters <- paste('filters=',URLencode(paste('{"op":"and","content":[', 
        content, ']}', sep='')),sep='')
    
    expand <- paste('analysis', 'analysis.input_files', 'associated_entities',
        'cases', 'cases.diagnoses','cases.diagnoses.treatments', 
        'cases.demographic', 'cases.project', 'cases.samples', 
        'cases.samples.portions', 'cases.samples.portions.analytes', 
        'cases.samples.portions.analytes.aliquots',
        'cases.samples.portions.slides', sep=',')
    
    expand <- paste('expand=', expand, sep='')
    
    payload <- paste(filters, 'pretty=true', 'format=JSON', 
        'size=10000', expand, sep='&')
    url <- paste(urlAPI, payload, sep='')
    
    return (url)
}

##' @title Match samples in metadata and expression matrix
##' @description Check if samples in the metadata and expression data match
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @return A logical value. If \code{TRUE}, all the samples matched
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' gdcMatchSamples(metadata=metaMatrix, rna.expr=rnaExpr)
gdcMatchSamples <- function(metadata, rna.expr) {
    correctNum <- sum(metadata$sample==colnames(rna.expr))

    if (correctNum == nrow(metadata) & correctNum == ncol(rna.expr)) {
        ('Samples matched')
    }
}

##' @title Univariate survival analysis of multiple genes
##' @description 
##'     Univariate Cox Proportional-Hazards and Kaplan Meier 
##'     survival analysis of a vector of genes
##' @param gene a vector of Ensembl gene ids
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @param method method for survival analysis. Possible values are 
##'     \code{'coxph'} and \code{'KM'}. Default is \code{'coxph'}
##' @param sep which point should be used to separate low-expression 
##'     and high-expression groups for \code{method='KM'}.
##'     Possible values are \code{'1stQu'}, \code{'mean'}, 
##'     \code{'median'}, and \code{'3rdQu'}. Default is \code{'median'} 
##' @importFrom survival coxph
##' @importFrom survival Surv
##' @return A dataframe or numeric matrix of hazard ratio, 95\% 
##'     confidence interval, p value, and FDR
##' @references
##'     Therneau TM, Lumley T. Package ‘survival’. \cr
##'     Andersen PK, Gill RD. Cox's regression model for 
##'     counting processes: a large sample study. 
##'     The annals of statistics. 1982 Dec 1:1100-20. \cr
##'     Therneau TM, Grambsch PM. Extending the Cox model. 
##'     Edited by P. Bickel, P. Diggle, S. Fienberg, K. Krickeberg. 
##'     2000:51. \cr
##'     Harrington DP, Fleming TR. A class of rank test procedures 
##'     for censored survival data.Biometrika. 1982 Dec 1;69(3):553-66.
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
##'             'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
##'              
##' metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' survOutput <- gdcSurvivalAnalysis(gene=genes,
##'     rna.expr=rnaExpr, metadata=metaMatrix)
gdcSurvivalAnalysis <- function(gene, rna.expr, metadata, 
    method='coxph', sep='median') {

    if (method=='coxph') {
        survOutput <- coxphTestFun(gene, rna.expr, metadata)
    } else if (method=='KM') {
        survOutput <- kmTestFun(gene, rna.expr, metadata, sep=sep)
    }
    
    return (survOutput)
}


###
coxphTestFun <- function(genes, rna.expr, metaMatrix) {

    metaMatrix <- metaMatrix[metaMatrix$sample_type=='PrimaryTumor',]
    
    samples = intersect(colnames(rna.expr), metaMatrix$sample)
    exprDa=rna.expr[genes,samples]
    
    clinicalDa=metaMatrix[match(samples,metaMatrix$sample),]
    daysToDeath <- as.numeric(clinicalDa$days_to_death)
    nonComplt <- is.na(daysToDeath)
    
    vitalStatus <- as.numeric(ifelse(nonComplt, 0, 1))
    daysToDeath[nonComplt] <- 
        as.numeric(clinicalDa$days_to_last_follow_up[nonComplt])
    
    coxphDEGs <- c()
    for (i in seq_len(nrow(exprDa))) {
        DEG <- unlist(exprDa[i,])
        coxtest <- coxph(Surv(daysToDeath, vitalStatus) ~ DEG)
        
        summcph <- summary(coxtest)
        coeffs <- c(summcph$coefficients[,1:2], summcph$conf.int[,3:4], 
            summcph$coefficients[,5])
        coxphDEGs <- rbind(coxphDEGs, coeffs)
        
    }
    rownames(coxphDEGs) <- rownames(exprDa)
    
    colnames(coxphDEGs) <- c('coef','HR','lower95','upper95','pValue')
    coxphDEGs <- data.frame(symbol=ensembl2symbolFun(rownames(exprDa)),
        coxphDEGs)
    #coxphDEGs$FDR <- p.adjust(coxphDEGs$pValue, method='fdr')
    
    #o <- order(coxphDEGs$pValue)
    #coxphDEGs <- coxphDEGs[o,]
    
    return (coxphDEGs)
}


###
kmTestFun <- function(genes, rna.expr, metaMatrix, sep='median') {
    metaMatrix <- metaMatrix[metaMatrix$sample_type=='PrimaryTumor',]
    
    samples = intersect(colnames(rna.expr), metaMatrix$sample)
    exprDa=rna.expr[genes,samples]
    
    clinicalDa=metaMatrix[match(samples,metaMatrix$sample),]
    daysToDeath <- as.numeric(clinicalDa$days_to_death)
    nonComplt <- is.na(daysToDeath)
    
    vitalStatus <- as.numeric(ifelse(nonComplt, 0, 1))
    daysToDeath[nonComplt] <- 
        as.numeric(clinicalDa$days_to_last_follow_up[nonComplt])
    
    kmDEGs <- c()
    for (i in seq_len(nrow(exprDa))) {
        DEG <- unlist(exprDa[i,])
        
        if (sep=='1stQu') {
            thresh <- as.numeric(summary(DEG)[2])
        } else if (sep=='median') {
            thresh <- as.numeric(summary(DEG)[3])
        } else if (sep=='mean') {
            thresh <- as.numeric(summary(DEG)[4])
        } else if (sep=='3rdQu') {
            thresh <- as.numeric(summary(DEG)[5])
        }
        
        exprGroup <- DEG > thresh
        
        sdf <- survdiff(Surv(daysToDeath, vitalStatus) ~ exprGroup)
        pValue <- format(pchisq(sdf$chisq, length(sdf$n)-1, 
            lower.tail = FALSE),digits=3)
        #p.val = 1 - pchisq(data.survdiff$chisq, length(data.survdiff$n) - 1)
        
        HR = (sdf$obs[2]/sdf$exp[2])/(sdf$obs[1]/sdf$exp[1])
        upper95 = exp(log(HR) + qnorm(0.975)*sqrt(1/sdf$exp[2]+1/sdf$exp[1]))
        lower95 = exp(log(HR) - qnorm(0.975)*sqrt(1/sdf$exp[2]+1/sdf$exp[1]))
        
        kmDEGs <- rbind(kmDEGs, c(HR, lower95, upper95, pValue))
        
    }
    
    rownames(kmDEGs) <- rownames(exprDa)
    colnames(kmDEGs) <- c('HR','lower95','upper95','pValue')
    kmDEGs <- data.frame(symbol=ensembl2symbolFun(rownames(exprDa)), kmDEGs)
    #kmDEGs$FDR <- p.adjust(kmDEGs$pValue, method='fdr')
    
    #o <- order(coxphDEGs$pValue)
    #coxphDEGs <- coxphDEGs[o,]
    
    return (kmDEGs)
}

##' @title Correlation plot of two genes/miRNAs
##' @description Scatter plot showing the expression correlation 
##'     between two genes/miRNAs
##' @param gene1 an Ensembl gene id or miRBase v21 mature miRNA id
##' @param gene2 an Ensembl gene id or miRBase v21 mature miRNA id
##' @param rna.expr \code{\link[limma]{voom}} transformed expression data
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @return A scatter plot with line of best fit
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
##'         'ENSG00000001084','ENSG00000001167','ENSG00000001460')
##' 
##' samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01', 
##'             'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-11', 
##'             'TCGA-2F-A9KT-11', 'TCGA-2F-A9KW-11')
##'              
##' metaMatrix <- data.frame(sample_type=rep(c('PrimaryTumor',
##'                         'SolidTissueNormal'),each=3),
##'                         sample=samples,
##'                         days_to_death=seq(100,600,100),
##'                         days_to_last_follow_up=rep(NA,6))
##' 
##' rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
##'                     0.5,2.5,5.7,6.5,4.9,3.8,
##'                     2.1,2.9,5.9,5.7,4.5,3.5,
##'                     2.7,5.9,4.5,5.8,5.2,3.0,
##'                     2.5,2.2,5.3,4.4,4.4,2.9,
##'                     2.4,3.8,6.2,3.8,3.8,4.2),6,6)
##' rownames(rnaExpr) <- genes
##' colnames(rnaExpr) <- samples
##' gdcCorPlot(gene1 = 'ENSG00000000938', 
##'         gene2    = 'ENSG00000001084',
##'         rna.expr = rnaExpr,
##'         metadata = metaMatrix)
gdcCorPlot <- function(gene1, gene2, rna.expr, metadata) {

    samples = intersect(colnames(rna.expr), metadata$sample)
    
    lncDa=rna.expr[gene1,samples]
    pcDa=rna.expr[gene2,samples]
    sampleType=as.factor(metadata$sample_type)
    
    x <- cor.test(x=lncDa, y=pcDa, alternative = 'greater')
    
    c <- format(x$estimate, digits=3)
    p <- format(x$p.value, digits=3)
    
    corDa <- data.frame(lncDa=rna.expr[gene1,], pcDa=rna.expr[gene2,], 
        sampleType=as.factor(metadata$sample_type))
    
    
    xpos <- (min(lncDa)+max(lncDa))/2
    ypos <- as.numeric(summary(pcDa)[6])+0.5
    
    
    ggplot(corDa, aes(x=corDa$lncDa, y=corDa$pcDa)) + 
        geom_point(aes(shape=sampleType, color=sampleType)) + 
        xlab(paste(gene1,' (',ensembl2symbolFun(gene1),')',sep='')) +
        ylab(paste(gene2,' (',ensembl2symbolFun(gene2),')',sep='')) + 
        geom_smooth(method="lm",se=FALSE, col='darkgreen', size=0.5) + 
        scale_colour_manual(breaks = sampleType, 
            values = c('chocolate1', 'blue')) +
        ggplot2::annotate("text", x = xpos, y = ypos, 
            label = paste('cor=', c, ', p=', p, sep=''), size = 5) +
        theme_bw()+theme(legend.title = element_blank(),
            legend.text = element_text(size=14),
            axis.line = element_line(colour = "black"),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.border = element_rect(colour='white'),
            panel.background = element_blank(),
            axis.text = element_text(size=14),
            axis.title = element_text(size=14))
}

#' This is an easy-to-use package for downloading, organizing, 
#' and integrative analyzing RNA expression data in GDC with an 
#' emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory 
#' network in cancer.
#'
#' @name GDCRNATools-package
#' @aliases GDCRNATools-package GDCRNATools
#' @docType package
NULL



#' Output of \code{\link{gdcDEAnalysis}} for downstream analysis
#' @name DEGAll
#' @docType data
#' @keywords datasets
NULL


#' Output of \code{\link{gdcEnrichAnalysis}} for visualization
#' @name enrichOutput
#' @docType data
#' @keywords datasets
NULL


#' RNAseq counts data of TCGA-CHOL
#' @name rnaCounts
#' @docType data
#' @keywords datasets
NULL


#' miRNA counts data of TCGA-CHOL
#' @name mirCounts
#' @docType data
#' @keywords datasets
NULL


#' miRNA-lncRNA interactions
#' @name lncTarget
#' @docType data
#' @keywords datasets
NULL


#' miRNA-mRNA interactions
#' @name pcTarget
#' @docType data
#' @keywords datasets
NULL

##' @title Filter out duplicated samples
##' @description Filter out samples that are sequenced for two or more times
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @return A filtered dataframe of metadata without duplicated samples
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Parse metadata by project id and data type #######
##' metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
##' metaMatrix <- gdcFilterDuplicate(metadata=metaMatrix)
gdcFilterDuplicate <- function(metadata) {
    filter <- which(duplicated(metadata[,'sample']))
    if (length(filter) != 0) {
        metadata <- metadata[-filter,]
    }
    message (paste('Removed', length(filter), 'samples', sep=' '))
    return (metadata)
}


##' @title Filter out other type of samples
##' @description Filter out samples that are neither 
##'     \emph{Solid Tissue Normal} nor \emph{Primary Tumor}
##' @param metadata metadata parsed from \code{\link{gdcParseMetadata}}
##' @return A filtered dataframe of metadata with \emph{Solid Tissue Normal} 
##'     and \emph{Primary Tumor} samples only
##' @export
##' @author Ruidong Li and Han Qu
##' @examples 
##' ####### Parse metadata by project id and data type #######
##' metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
##' metaMatrix <- gdcFilterSampleType(metadata=metaMatrix)
gdcFilterSampleType <- function(metadata) {
    filter <- which(! metadata$sample_type %in% 
        c('PrimaryTumor', 'SolidTissueNormal'))
    if (length(filter) != 0) {
        metadata <- metadata[-filter,]
    }
    message (paste('Removed', length(filter), 'samples', sep=' '))
    return (metadata)
}

---
title: 'GDCRNATools: integrative analysis of protein coding genes, long non-coding genes, and microRNAs in GDC'
author: 'Ruidong Li and Han Qu'
date: "Last update: `r format(Sys.time(), '%d %B, %Y')`" 
vignette: >
  %\VignetteIndexEntry{'GDCRNATools: integrative analysis of protein coding genes, long non-coding genes, and microRNAs in GDC'}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  prettydoc::html_pretty:
    theme : 'hpstr'
    highlight: vignette 
    toc: true
    number_sections: true
---



# Introduction

The [Genomic Data Commons (GDC)](https://portal.gdc.cancer.gov/) maintains standardized genomic, clinical, and biospecimen data from National Cancer Institute (NCI) programs including [The Cancer Genome Atlas (TCGA)](https://tcga-data.nci.nih.gov/) and [Therapeutically Applicable Research To Generate Effective Treatments (TARGET)](https://ocg.cancer.gov/programs/target), It also accepts high quality datasets from non-NCI supported cancer research programs, such as genomic data from the [Foundation Medicine](https://www.foundationmedicine.com/).

`GDCRNATools` is an R package which provides a standard, easy-to-use and comprehensive pipeline for downloading, organizing, and integrative analyzing RNA expression data in the GDC portal with an emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory network in cancer.

Many analyses can be perfomed using GDCRNATools, including differential gene expression analysis ([limma](http://bioconductor.org/packages/release/bioc/html/limma.html), [edgeR](http://bioconductor.org/packages/release/bioc/html/edgeR.html), and [DESeq2](http://bioconductor.org/packages/release/bioc/html/DESeq2.html)), univariate survival analysis (CoxPH and KM), competing endogenous RNA network analysis (hypergeometric test, Pearson correlation analysis, regulation similarity analysis, sensitivity Pearson partial  correlation), and functional enrichment analysis(GO, KEGG, DO). Besides some routine visualization methods such as volcano plot, scatter plot, and bubble plot, etc., three simple shiny apps are developed in GDCRNATools allowing users visualize the results on a local webpage.

This user-friendly package allows researchers perform the analysis by simply running a few functions and integrate their own pipelines such as molecular subtype classification, [weighted correlation network analysis (WGCNA)](https://labs.genetics.ucla.edu/horvath/CoexpressionNetwork/Rpackages/WGCNA/), and TF-miRNA co-regulatory network analysis, etc. into the workflow easily.



# Installation
`GDCRNATools` is now under review in Bioconductor. Users can install the package from github temporarily using the `install_github()` function in `devtools` package.

Code to install and load `devtools`:
```R
install.pacakges('devtools')
library(devtools)
```

Code to install and load `GDCRNATools`:
```R
devtools::install_github(repo='Jialab-UCR/GDCRNATools')
library(GDCRNATools)
```



# Manual
A simply manual of `GDCRNATools` is available online [GDCRNATools Manual](https://github.com/Jialab-UCR/GDCRNATools/blob/master/vignettes/GDCRNATools.Rmd). Users are also highly recommended to download the comprhensive manual in _.html_ format and view on local computer [GDCRNATools Manual](https://github.com/Jialab-UCR/Jialab-UCR.github.io/blob/master/GDCRNATools_manual.html)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcFilterSamples.R
\name{gdcFilterDuplicate}
\alias{gdcFilterDuplicate}
\title{Filter out duplicated samples}
\usage{
gdcFilterDuplicate(metadata)
}
\arguments{
\item{metadata}{metadata parsed from \code{\link{gdcParseMetadata}}}
}
\value{
A filtered dataframe of metadata without duplicated samples
}
\description{
Filter out samples that are sequenced for two or more times
}
\examples{
####### Parse metadata by project id and data type #######
metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
metaMatrix <- gdcFilterDuplicate(metadata=metaMatrix)
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcClinical.R
\name{gdcClinicalDownload}
\alias{gdcClinicalDownload}
\title{Download clinical data in GDC}
\usage{
gdcClinicalDownload(manifest = NULL, project.id,
  directory = "Clinical", write.manifest = FALSE,
  method = "gdc-client")
}
\arguments{
\item{manifest}{menifest file that is downloaded from the GDC cart. 
If provided, files whose UUIDs are in the manifest file will be 
downloaded via gdc-client, otherwise, \code{project id} argument 
should be provided to download data automatically. 
Default is \code{NULL}}

\item{project.id}{project id in GDC}

\item{directory}{the folder to save downloaded files. 
Default is \code{'Clinical'}}

\item{write.manifest}{logical, whether to write out the manifest file}

\item{method}{method that is used to download data. Either 
\code{'GenomicDataCommons'} which is a well established method 
developed in the \pkg{GenomicDataCommons'} package, or alternatively 
\code{'gdc-client'} which uses the \code{gdc-client} tool developed 
by GDC. Default is \code{'gdc-client'}.}
}
\value{
downloaded files in the specified directory
}
\description{
Download clinical data in GDC 
    either by providing the manifest file or 
    specifying the project id and data type
}
\examples{
####### Download Clinical data by manifest file #######
manifest <- 'Clinical.manifest.txt'
\dontrun{gdcClinicalDownload(manifest  = manifest,
                    directory = 'Clinical')}
                   
####### Download Clinical data by project id #######
project <- 'TCGA-PRAD'
\dontrun{gdcClinicalDownload(project.id     = project, 
                    write.manifest = TRUE,
                    directory      = 'Clinical')}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{DEGAll}
\alias{DEGAll}
\title{Output of \code{\link{gdcDEAnalysis}} for downstream analysis}
\description{
Output of \code{\link{gdcDEAnalysis}} for downstream analysis
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcEnrichmentAnalysis.R
\name{gdcEnrichAnalysis}
\alias{gdcEnrichAnalysis}
\title{Functional enrichment analysis}
\usage{
gdcEnrichAnalysis(gene, simplify = TRUE, level = 0)
}
\arguments{
\item{gene}{a vector of Ensembl gene id}

\item{simplify}{logical, specifying whether to remove redundant GO terms. 
Default \code{simplify=TRUE}}

\item{level}{a numeric value, restrict the GO enrichment result at a 
specific GO level. Default is \code{0}, which means all terms 
should be returned}
}
\value{
A dataframe of enrichment analysis result containing 
    enriched terms, number of overlpped genes, p value of 
    hypergeometric test, fdr, fold of enrichment, Ensembl gene ids, 
    gene symbols, and functional categories, etc.
}
\description{
Performs Gene Ontology (GO), Kyoto Encyclopedia of Genes 
    and Genomes (KEGG) pathway and Disease Ontology (DO) enrichment 
    analyses by \pkg{clusterProfiler} and \pkg{DOSE} packages
}
\examples{
####### GO, KEGG, DO enrichment analysis #######
deg <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')
\dontrun{enrichOutput <- gdcEnrichAnalysis(gene=deg, simplify=TRUE)}
}
\references{
Yu G, Wang LG, Han Y, He QY. clusterProfiler: an R package for 
    comparing biological themes among gene clusters. 
    Omics: a journal of integrative biology. 2012 May 1;16(5):284-7. \cr
    Yu G, Wang LG, Yan GR, He QY. DOSE: an R/Bioconductor package for 
    disease ontology semantic and enrichment analysis. Bioinformatics. 
    2014 Oct 17;31(4):608-9.
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcDEGVisulization.R
\name{gdcVolcanoPlot}
\alias{gdcVolcanoPlot}
\title{Volcano plot of differentially expressed genes/miRNAs}
\usage{
gdcVolcanoPlot(deg.all, fc = 2, pval = 0.01)
}
\arguments{
\item{deg.all}{a dataframe generated from \code{\link{gdcDEAnalysis}} 
containing all genes of analysis no matter they are differentially 
expressed or not}

\item{fc}{a numeric value specifying the threshold of fold change}

\item{pval}{a nuemric value specifying the threshold of p value}
}
\value{
A volcano plot
}
\description{
A volcano plot showing differentially expressed genes/miRNAs
}
\examples{
genes <- c('ENSG00000231806','ENSG00000261211','ENSG00000260920',
        'ENSG00000228594','ENSG00000125170','ENSG00000179909',
        'ENSG00000280012','ENSG00000134612','ENSG00000213071')
symbol <- c('PCAT7','AL031123.2','AL031985.3',
            'FNDC10','DOK4','ZNF154',
            'RPL23AP61','FOLH1B','LPAL2')
group <- rep(c('long_non_coding','protein_coding','pseudogene'), each=3)
logFC <- c(2.8,2.3,-1.1,1.9,-1.2,-1.6,1.5,2.1,-1.1)
FDR <- rep(c(0.1,0.00001,0.0002), each=3)
deg <- data.frame(symbol, group, logFC, FDR)
rownames(deg) <- genes
gdcVolcanoPlot(deg.all=deg)
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{mirCounts}
\alias{mirCounts}
\title{miRNA counts data of TCGA-CHOL}
\description{
miRNA counts data of TCGA-CHOL
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcVoomNormalization.R
\name{gdcVoomNormalization}
\alias{gdcVoomNormalization}
\title{TMM normalization and voom transformation}
\usage{
gdcVoomNormalization(counts, filter = TRUE)
}
\arguments{
\item{counts}{raw counts of RNA/miRNA expression data}

\item{filter}{logical, whether to filter out low-expression genes. 
If \code{TRUE}, only genes with \code{cpm > 1} in more than half 
of the samples will be kept. Default is \code{TRUE}}
}
\value{
A dataframe or numeric matrix of TMM normalized and 
    \code{\link[limma]{voom}} transformed expression values on 
    the log2 scale
}
\description{
Normalize raw counts data by TMM implemented in \pkg{edgeR} 
    and then transform it by \code{\link[limma]{voom}} in \pkg{limma}
}
\examples{
####### Normalization #######
rnaMatrix <- matrix(sample(1:100,100), 4, 25)
rnaExpr <- gdcVoomNormalization(counts=rnaMatrix, filter=FALSE)
}
\references{
Robinson MD, McCarthy DJ, Smyth GK. edgeR: a Bioconductor package 
    for differential expression analysis of digital gene expression data. 
    Bioinformatics. 2010 Jan 1;26(1):139-40. \cr
    Law CW, Chen Y, Shi W, Smyth GK. Voom: precision weights unlock 
    linear model analysis tools for RNA-seq read counts. Genome biology. 
    2014 Feb 3;15(2):R29.
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{rnaCounts}
\alias{rnaCounts}
\title{RNAseq counts data of TCGA-CHOL}
\description{
RNAseq counts data of TCGA-CHOL
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcFilterSamples.R
\name{gdcFilterSampleType}
\alias{gdcFilterSampleType}
\title{Filter out other type of samples}
\usage{
gdcFilterSampleType(metadata)
}
\arguments{
\item{metadata}{metadata parsed from \code{\link{gdcParseMetadata}}}
}
\value{
A filtered dataframe of metadata with \emph{Solid Tissue Normal} 
    and \emph{Primary Tumor} samples only
}
\description{
Filter out samples that are neither 
    \emph{Solid Tissue Normal} nor \emph{Primary Tumor}
}
\examples{
####### Parse metadata by project id and data type #######
metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
metaMatrix <- gdcFilterSampleType(metadata=metaMatrix)
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{package}
\name{GDCRNATools-package}
\alias{GDCRNATools-package}
\alias{GDCRNATools}
\title{This is an easy-to-use package for downloading, organizing, 
and integrative analyzing RNA expression data in GDC with an 
emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory 
network in cancer.}
\description{
This is an easy-to-use package for downloading, organizing, 
and integrative analyzing RNA expression data in GDC with an 
emphasis on deciphering the lncRNA-mRNA related ceRNA regulatory 
network in cancer.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcEnrichmentPlots.R
\name{gdcEnrichPlot}
\alias{gdcEnrichPlot}
\title{Plots for enrichment analysis}
\usage{
gdcEnrichPlot(enrichment, type = "bar", category = "KEGG",
  num.terms = 10, bar.color = "black")
}
\arguments{
\item{enrichment}{a dataframe generated from 
\code{\link{gdcEnrichAnalysis}}}

\item{type}{type of the plot, should be one of \code{'bar'} 
and \code{'bubble'}}

\item{category}{which category should be plotted. Possible values are 
\code{'KEGG'}, \code{'GO'}, \code{'GO_BP'}, \code{'GO_CC'}, 
\code{'GO_MF'}, and \code{'DO'}.
Default is \code{'KEGG'}}

\item{num.terms}{number of terms to be plotted. Default is \code{10}}

\item{bar.color}{color of the bar plot. Default is \code{'black'}}
}
\value{
A bar plot or bubble plot of functional enrichment analysis
}
\description{
Bar plot and bubble plot for GO, KEGG, 
    and DO functional enrichment analysis
}
\examples{
####### Enrichment plots #######
enrichOutput<-data.frame(Terms=c('hsa05414~Dilated cardiomyopathy (DCM)',
                                'hsa04510~Focal adhesion',
                                'hsa05205~Proteoglycans in cancer'),
                            Category=rep('KEGG',3), 
                            FDR=c(0.001,0.002,0.003))
gdcEnrichPlot(enrichment=enrichOutput, type='bar', category='KEGG')
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcRNADownload.R
\name{gdcRNADownload}
\alias{gdcRNADownload}
\title{Download RNA data in GDC}
\usage{
gdcRNADownload(manifest = NULL, project.id, data.type,
  directory = "Data", write.manifest = FALSE, method = "gdc-client")
}
\arguments{
\item{manifest}{menifest file that is downloaded from the GDC cart. 
If provided, files whose UUIDs are in the manifest file 
will be downloaded via gdc-client, otherwise, \code{project} and 
\code{data.type} arguments should be provided to download 
data automatically. Default is \code{NULL}}

\item{project.id}{project id in GDC}

\item{data.type}{one of \code{'RNAseq'} and \code{'miRNAs'}}

\item{directory}{the folder to save downloaded files. 
Default is \code{'Data'}}

\item{write.manifest}{logical, whether to write out the manifest file}

\item{method}{method that is used to download data. Either 
\code{'GenomicDataCommons'} which is a well established method 
developed in the \pkg{GenomicDataCommons'} package, or alternatively 
\code{'gdc-client'} which uses the \code{gdc-client} tool developed 
by GDC. Default is \code{'gdc-client'}.}
}
\value{
Downloaded files in the specified directory
}
\description{
Download gene expression quantification 
    and isoform expression quantification data from GDC 
    either by providing the manifest file or by sepcifying 
    the project id and data type
}
\examples{
####### Download RNA data by menifest file #######
manifest <- 'RNAseq.manifest.txt'
\dontrun{gdcRNADownload(manifest=manifest)}

####### Download RNA data by project id and data type #######
project <- 'TCGA-PRAD'
\dontrun{gdcRNADownload(project.id=project, data.type='RNAseq')}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{enrichOutput}
\alias{enrichOutput}
\title{Output of \code{\link{gdcEnrichAnalysis}} for visualization}
\description{
Output of \code{\link{gdcEnrichAnalysis}} for visualization
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcParseMetadata.R
\name{gdcParseMetadata}
\alias{gdcParseMetadata}
\title{Parse metadata}
\usage{
gdcParseMetadata(metafile = NULL, project.id, data.type,
  write.meta = FALSE)
}
\arguments{
\item{metafile}{metadata file in \code{.json} format download 
from GDC cart. If provided, the metadata will be parsed from 
this file, otherwise, \code{project} and \code{data.type} arguments 
should be provided to retrieve metadata automatically. 
Default is \code{NULL}}

\item{project.id}{project id in GDC}

\item{data.type}{one of \code{'RNAseq'} and \code{'miRNAs'}}

\item{write.meta}{logical, whether to write the metadata to a 
\code{.json} file}
}
\value{
A dataframe of metadata containing file_name, 
    sample_id, etc. as well as some basic clinical data
}
\description{
Parse metadata either by providing the \emph{.json} 
    file that is downloaded from GDC cart or by parse metadata 
    automatically by providing the projct id and data type
}
\examples{
####### Merge RNA expression data #######
metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', data.type='RNAseq')
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcDEAnalysis.R
\name{gdcDEReport}
\alias{gdcDEReport}
\title{Report differentially expressed genes/miRNAs}
\usage{
gdcDEReport(deg, gene.type = "all", fc = 2, pval = 0.01)
}
\arguments{
\item{deg}{A dataframe of DE analysis result from 
\code{\link{gdcDEAnalysis}}}

\item{gene.type}{one of \code{'all'}, \code{'long_non_coding'}, 
\code{'protein_coding'}, and \code{'miRNAs'}. Default is \code{'all'}}

\item{fc}{a numeric value specifying the threshold of fold change}

\item{pval}{a nuemric value specifying the threshold of p value}
}
\value{
A dataframe or numeric matrix of differentially expressed 
    genes/miRNAs
}
\description{
Report genes/miRNAs that are differentially expressed 
    satisfying a given threshold
}
\examples{
genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')

samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
            'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-11',
             'TCGA-2F-A9KT-11', 'TCGA-2F-A9KW-11')
             
metaMatrix <- data.frame(sample_type=rep(c('PrimaryTumor',
                        'SolidTissueNormal'),each=3),
                        sample=samples,
                        days_to_death=seq(100,600,100),
                        days_to_last_follow_up=rep(NA,6))
rnaMatrix <- matrix(c(6092,11652,5426,4383,3334,2656,
                    8436,2547,7943,3741,6302,13976,
                    1506,6467,5324,3651,1566,2780,
                    834,4623,10275,5639,6183,4548,
                    24702,43,1987,269,3322,2410,
                    2815,2089,3804,230,883,5415), 6,6)
rownames(rnaMatrix) <- genes
colnames(rnaMatrix) <- samples
DEGAll <- gdcDEAnalysis(counts     = rnaMatrix, 
                        group      = metaMatrix$sample_type, 
                        comparison = 'PrimaryTumor-SolidTissueNormal', 
                        method     = 'limma')
dePC <- gdcDEReport(deg=DEGAll)
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcCEAnalysis.R
\name{gdcCEAnalysis}
\alias{gdcCEAnalysis}
\title{Competing endogenous RNAs (ceRNAs) analysis}
\usage{
gdcCEAnalysis(lnc, pc, deMIR = NULL, lnc.targets = "starBase",
  pc.targets = "starBase", rna.expr, mir.expr)
}
\arguments{
\item{lnc}{a vector of Ensembl long non-coding gene ids}

\item{pc}{a vector of Ensembl protein coding gene ids}

\item{deMIR}{a vector of differentially expressed miRNAs. 
Default is \code{NULL}}

\item{lnc.targets}{a character string specifying the database 
of miRNA-lncRNA interactions.
Should be one of \code{'spongeScan'}, \code{'starBase'}, 
and \code{'miRcode'}. Default is \code{'starBase'}. \cr\cr
Or a \code{list} of miRNA-lncRNA interactions generated by users}

\item{pc.targets}{a character string specifying the database of 
miRNA-lncRNA interactions.
Should be one of \code{'spongeScan'}, \code{'starBase'}, 
and \code{'miRcode'}. Default is \code{'starBase'}. \cr\cr
Or a \code{list} of miRNA-lncRNA interactions generated by users}

\item{rna.expr}{\code{\link[limma]{voom}} 
transformed gene expression data}

\item{mir.expr}{\code{\link[limma]{voom}} 
transformed mature miRNA expression data}
}
\value{
A dataframe containing ceRNA pairs, expression correlation 
    between lncRNA and mRNA, the number and hypergeometric significance 
    of shared miRNAs, regulation similarity score, and the mean sensitity 
    correlation (the difference between Pearson correlation and partial 
    correlation) of multiple lncRNA-miRNA-mRNA triplets, etc.
}
\description{
Identify ceRNAs by 
    (1) number of shared miRNAs between lncRNA and mRNA; 
    (2) expression correlation of lncRNA and mRNA;
    (3) regulation similarity of shared miRNAs on lncRNA and mRNA;
    (4) sensitivity correlation
}
\examples{
####### ceRNA network analysis #######
deLNC <- c('ENSG00000260920','ENSG00000242125','ENSG00000261211')
dePC <- c('ENSG00000043355','ENSG00000109586','ENSG00000144355')
genes <- c(deLNC, dePC)
samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01', 
            'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01', 
            'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
rnaExpr <- data.frame(matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
                    0.5,2.5,5.7,6.5,4.9,3.8,
                    2.1,2.9,5.9,5.7,4.5,3.5,
                    2.7,5.9,4.5,5.8,5.2,3.0,
                    2.5,2.2,5.3,4.4,4.4,2.9,
                    2.4,3.8,6.2,3.8,3.8,4.2),6,6), 
                    stringsAsFactors=FALSE)
rownames(rnaExpr) <- genes
colnames(rnaExpr) <- samples

mirExpr <- data.frame(matrix(c(7.7,7.4,7.9,8.9,8.6,9.5,
                    5.1,4.4,5.5,8.5,4.4,3.5,
                    4.9,5.5,6.9,6.1,5.5,4.1,
                    12.4,13.5,15.1,15.4,13.0,12.8,
                    2.5,2.2,5.3,4.4,4.4,2.9,
                    2.4,2.7,6.2,1.5,4.4,4.2),6,6),
                    stringsAsFactors=FALSE)
colnames(mirExpr) <- samples
rownames(mirExpr) <- c('hsa-miR-340-5p','hsa-miR-181b-5p',
                    'hsa-miR-181a-5p', 'hsa-miR-181c-5p',
                    'hsa-miR-199b-5p','hsa-miR-182-5p')

ceOutput <- gdcCEAnalysis(lnc       = deLNC, 
                        pc          = dePC, 
                        lnc.targets = 'starBase', 
                        pc.targets  = 'starBase', 
                        rna.expr    = rnaExpr, 
                        mir.expr    = mirExpr)
}
\references{
Paci P, Colombo T, Farina L. Computational analysis identifies 
    a sponge interaction network  between long non-coding RNAs and 
    messenger RNAs in human breast cancer.  BMC systems biology. 
    2014 Jul 17;8(1):83.
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcClinical.R
\name{gdcClinicalMerge}
\alias{gdcClinicalMerge}
\title{Merge clinical data}
\usage{
gdcClinicalMerge(path, key.info = TRUE, organized = FALSE)
}
\arguments{
\item{path}{path to downloaded files for merging}

\item{key.info}{logical, whether to return the key clinical 
information only. If \code{TRUE}, only clinical information 
such as age, stage, grade, overall survial, etc. will be returned}

\item{organized}{logical, whether the clinical data have already
been organized into a single folder (eg., data downloaded by the
'GenomicDataCommons' method are already organized). 
Default is \code{FALSE}.}
}
\value{
A dataframe of clinical data with rows are patients 
    and columns are clinical traits
}
\description{
Merge clinical data in \code{.xml} files 
    that are downloaded from GDC to a dataframe
}
\examples{
####### Merge clinical data #######
path <- 'Clinical/'
\dontrun{clinicalDa <- gdcClinicalMerge(path=path, key.info=TRUE)}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcExportNetwork.R
\name{gdcExportNetwork}
\alias{gdcExportNetwork}
\title{Export network for Cytoscape}
\usage{
gdcExportNetwork(ceNetwork, net)
}
\arguments{
\item{ceNetwork}{a dataframe generated from \code{\link{gdcCEAnalysis}}}

\item{net}{one of \code{'nodes'} and \code{'edges'}}
}
\value{
A dataframe of nodes or edges
}
\description{
Export nodes and edges of ce network for 
    \strong{Cytoscape} visualization
}
\examples{
####### ceRNA network analysis #######
ceOutput <- data.frame(lncRNAs=c('ENSG00000242125','ENSG00000242125',
                                'ENSG00000245532'), 
                    Genes=c('ENSG00000043355','ENSG00000109586',
                                'ENSG00000144355'), 
                    miRNAs=c('hsa-miR-340-5p','hsa-miR-340-5p',
                            'hsa-miR-320b,hsa-miR-320d,
                            hsa-miR-320c,hsa-miR-320a'),
                    Counts=c(1,1,4), stringsAsFactors=FALSE)
####### Export edges #######
edges <- gdcExportNetwork(ceNetwork=ceOutput, net='edges')

####### Export nodes #######
\dontrun{nodes <- gdcExportNetwork(ceNetwork=ceOutput, net='nodes')}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcRNAMerge.R
\name{gdcRNAMerge}
\alias{gdcRNAMerge}
\title{Merge RNA/miRNAs raw counts data}
\usage{
gdcRNAMerge(metadata, path, data.type, organized = FALSE)
}
\arguments{
\item{metadata}{metadata parsed from \code{\link{gdcParseMetadata}}}

\item{path}{path to downloaded files for merging}

\item{data.type}{one of \code{'RNAseq'} and \code{'miRNAs'}}

\item{organized}{logical, whether the raw counts data have already
been organized into a single folder (eg., data downloaded by the
'GenomicDataCommons' method are already organized). 
Default is \code{FALSE}.}
}
\value{
A dataframe or numeric matrix of raw counts data with rows 
    are genes or miRNAs and columns are samples
}
\description{
Merge raw counts data that is downloaded from GDC to a 
    single expression matrix
}
\examples{
####### Merge RNA expression data #######
metaMatrix <- gdcParseMetadata(project.id='TARGET-RT', 
    data.type='RNAseq')
\dontrun{rnaExpr <- gdcRNAMerge(metadata=metaMatrix, path='RNAseq/', 
    data.type='RNAseq')}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcSurvivalAnalysis.R
\name{gdcSurvivalAnalysis}
\alias{gdcSurvivalAnalysis}
\title{Univariate survival analysis of multiple genes}
\usage{
gdcSurvivalAnalysis(gene, rna.expr, metadata, method = "coxph",
  sep = "median")
}
\arguments{
\item{gene}{a vector of Ensembl gene ids}

\item{rna.expr}{\code{\link[limma]{voom}} transformed expression data}

\item{metadata}{metadata parsed from \code{\link{gdcParseMetadata}}}

\item{method}{method for survival analysis. Possible values are 
\code{'coxph'} and \code{'KM'}. Default is \code{'coxph'}}

\item{sep}{which point should be used to separate low-expression 
and high-expression groups for \code{method='KM'}.
Possible values are \code{'1stQu'}, \code{'mean'}, 
\code{'median'}, and \code{'3rdQu'}. Default is \code{'median'}}
}
\value{
A dataframe or numeric matrix of hazard ratio, 95\% 
    confidence interval, p value, and FDR
}
\description{
Univariate Cox Proportional-Hazards and Kaplan Meier 
    survival analysis of a vector of genes
}
\examples{
genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')

samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
            'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
            'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
             
metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
                        sample=samples,
                        days_to_death=seq(100,600,100),
                        days_to_last_follow_up=rep(NA,6))
rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
                    0.5,2.5,5.7,6.5,4.9,3.8,
                    2.1,2.9,5.9,5.7,4.5,3.5,
                    2.7,5.9,4.5,5.8,5.2,3.0,
                    2.5,2.2,5.3,4.4,4.4,2.9,
                    2.4,3.8,6.2,3.8,3.8,4.2),6,6)
rownames(rnaExpr) <- genes
colnames(rnaExpr) <- samples
survOutput <- gdcSurvivalAnalysis(gene=genes,
    rna.expr=rnaExpr, metadata=metaMatrix)
}
\references{
Therneau TM, Lumley T. Package ‘survival’. \cr
    Andersen PK, Gill RD. Cox's regression model for 
    counting processes: a large sample study. 
    The annals of statistics. 1982 Dec 1:1100-20. \cr
    Therneau TM, Grambsch PM. Extending the Cox model. 
    Edited by P. Bickel, P. Diggle, S. Fienberg, K. Krickeberg. 
    2000:51. \cr
    Harrington DP, Fleming TR. A class of rank test procedures 
    for censored survival data.Biometrika. 1982 Dec 1;69(3):553-66.
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcDEAnalysis.R
\name{gdcDEAnalysis}
\alias{gdcDEAnalysis}
\title{Differential gene expression analysis}
\usage{
gdcDEAnalysis(counts, group, comparison, method = "limma",
  n.cores = NULL, filter = TRUE)
}
\arguments{
\item{counts}{a dataframe or numeric matrix of raw counts data generated 
from \code{\link{gdcRNAMerge}}}

\item{group}{a vector giving the group that each sample belongs to}

\item{comparison}{a character string specifying the two groups 
being compared. \cr
Example: \code{comparison='PrimaryTumor-SolidTissueNormal'}}

\item{method}{one of \code{'limma'}, \code{'edgeR'}, and 
\code{'DESeq2'}. Default is \code{'limma'} \cr
Note: It may takes long time for \code{method='DESeq2'} 
with a single core}

\item{n.cores}{a numeric value of cores to be used for 
\code{method='DESeq2'} to accelate the analysis process. 
Default is \code{NULL}}

\item{filter}{logical, whether to filter out low expression genes. 
If \code{TRUE}, only genes 
with \code{cpm > 1} in more than half of the samples will be kept. 
Default is \code{TRUE}}
}
\value{
A dataframe containing Ensembl gene ids/miRBase v21 mature 
    miRNA ids, gene symbols, biotypes, fold change on the log2 scale, 
    p value, and FDR etc. of all genes/miRNAs of analysis.
}
\description{
Performs differential gene expression analysis by 
    \pkg{limma}, \pkg{edgeR}, and \pkg{DESeq2}
}
\note{
It may takes long time for \code{method='DESeq2'} with a 
    single core. Please use multiple cores if possible
}
\examples{
genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')

samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
            'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-11', 
            'TCGA-2F-A9KT-11', 'TCGA-2F-A9KW-11')

metaMatrix <- data.frame(sample_type=rep(c('PrimaryTumor',
                    'SolidTissueNormal'),each=3),
                    sample=samples,
                    days_to_death=seq(100,600,100),
                    days_to_last_follow_up=rep(NA,6))
rnaMatrix <- matrix(c(6092,11652,5426,4383,3334,2656,
                    8436,2547,7943,3741,6302,13976,
                    1506,6467,5324,3651,1566,2780,
                    834,4623,10275,5639,6183,4548,
                    24702,43,1987,269,3322,2410,
                    2815,2089,3804,230,883,5415), 6,6)
rownames(rnaMatrix) <- genes
colnames(rnaMatrix) <- samples
DEGAll <- gdcDEAnalysis(counts     = rnaMatrix, 
                        group      = metaMatrix$sample_type, 
                        comparison = 'PrimaryTumor-SolidTissueNormal', 
                        method     = 'limma')
}
\references{
Robinson MD, McCarthy DJ, Smyth GK. edgeR: a Bioconductor package 
    for differential expression analysis of digital gene expression data. 
    Bioinformatics. 2010 Jan 1;26(1):139-40. \cr
    Ritchie ME, Phipson B, Wu D, Hu Y, Law CW, Shi W, Smyth GK. 
    limma powers differential expression analyses for RNA-sequencing and 
    microarray studies. Nucleic acids research. 2015 Jan 20;
    43(7):e47-e47. \cr
    Love MI, Huber W, Anders S. Moderated estimation of fold change and 
    dispersion for RNA-seq data with DESeq2. Genome biology. 2014 Dec 5;
    15(12):550.
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcShinyPlot.R
\name{shinyPathview}
\alias{shinyPathview}
\title{Shiny pathview}
\usage{
shinyPathview(gene, pathways, directory = ".")
}
\arguments{
\item{gene}{a vector of numeric values (eg. fold change on log2 scale) 
with names are Ensembl gene ids}

\item{pathways}{a vector of KEGG pathway ids}

\item{directory}{the folder to save pathway figures. 
Default is the working directory}
}
\value{
a local webpage for visualization of KEGG maps
}
\description{
A simple \pkg{shiny} app to show pathways genetrated by 
    \pkg{pathview} package on local web browser
}
\examples{
genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')
pathways <- c("hsa05414~Dilated cardiomyopathy (DCM)",
            "hsa05410~Hypertrophic cardiomyopathy (HCM)",
            "hsa05412~Arrhythmogenic right ventricular cardiomyopathy",
            "hsa04512~ECM-receptor interaction",
            "hsa04510~Focal adhesion",
            "hsa04360~Axon guidance",
            "hsa04270~Vascular smooth muscle contraction",
            "hsa05205~Proteoglycans in cancer",
            "hsa04022~cGMP-PKG signaling pathway",
            "hsa00480~Glutathione metabolism")
\dontrun{shinyPathview(gene=genes, pathways=pathways)}
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{pcTarget}
\alias{pcTarget}
\title{miRNA-mRNA interactions}
\description{
miRNA-mRNA interactions
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcDEGVisulization.R
\name{gdcBarPlot}
\alias{gdcBarPlot}
\title{Bar plot of differentially expressed genes/miRNAs}
\usage{
gdcBarPlot(deg, angle = 0, data.type)
}
\arguments{
\item{deg}{a dataframe generated from \code{\link{gdcDEReport}} 
containing DE genes/miRNAs ids, logFC, etc.}

\item{angle}{a numeric value specifying the angle of text on x-axis. 
Default is \code{0}}

\item{data.type}{one of \code{'RNAseq'} and \code{'miRNAs'}}
}
\value{
A bar plot
}
\description{
A bar plot showing the number of down-regulated and 
    up-regulated DE genes/miRNAs of different biotypes
}
\examples{
genes <- c('ENSG00000231806','ENSG00000261211','ENSG00000260920',
        'ENSG00000228594','ENSG00000125170','ENSG00000179909',
        'ENSG00000280012','ENSG00000134612','ENSG00000213071')
symbol <- c('PCAT7','AL031123.2','AL031985.3',
            'FNDC10','DOK4','ZNF154',
            'RPL23AP61','FOLH1B','LPAL2')
group <- rep(c('long_non_coding','protein_coding','pseudogene'), each=3)
logFC <- c(2.8,2.3,-1.1,1.9,-1.2,-1.6,1.5,2.1,-1.1)
FDR <- rep(c(0.1,0.00001,0.0002), each=3)
deg <- data.frame(symbol, group, logFC, FDR)
rownames(deg) <- genes
gdcBarPlot(deg, angle=45, data.type='RNAseq')
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdcMatchSamples.R
\name{gdcMatchSamples}
\alias{gdcMatchSamples}
\title{Match samples in metadata and expression matrix}
\usage{
gdcMatchSamples(metadata, rna.expr)
}
\arguments{
\item{metadata}{metadata parsed from \code{\link{gdcParseMetadata}}}

\item{rna.expr}{\code{\link[limma]{voom}} transformed expression data}
}
\value{
A logical value. If \code{TRUE}, all the samples matched
}
\description{
Check if samples in the metadata and expression data match
}
\examples{
genes <- c('ENSG00000000938','ENSG00000000971','ENSG00000001036',
        'ENSG00000001084','ENSG00000001167','ENSG00000001460')

samples <- c('TCGA-2F-A9KO-01', 'TCGA-2F-A9KP-01',
            'TCGA-2F-A9KQ-01', 'TCGA-2F-A9KR-01',
            'TCGA-2F-A9KT-01', 'TCGA-2F-A9KW-01')
             
metaMatrix <- data.frame(sample_type=rep('PrimaryTumor',6),
                        sample=samples,
                        days_to_death=seq(100,600,100),
                        days_to_last_follow_up=rep(NA,6))
rnaExpr <- matrix(c(2.7,7.0,4.9,6.9,4.6,2.5,
                    0.5,2.5,5.7,6.5,4.9,3.8,
                    2.1,2.9,5.9,5.7,4.5,3.5,
                    2.7,5.9,4.5,5.8,5.2,3.0,
                    2.5,2.2,5.3,4.4,4.4,2.9,
                    2.4,3.8,6.2,3.8,3.8,4.2),6,6)
rownames(rnaExpr) <- genes
colnames(rnaExpr) <- samples
gdcMatchSamples(metadata=metaMatrix, rna.expr=rnaExpr)
}
\author{
Ruidong Li and Han Qu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDCRNATools-package.R
\docType{data}
\name{lncTarget}
\alias{lncTarget}
\title{miRNA-lncRNA interactions}
\description{
miRNA-lncRNA interactions
}
\keyword{datasets}
